package org.act.metaset;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;
import java.util.StringTokenizer;

public class Metaset implements Cloneable {
	
	private String namespace = null;
	
	private String name = null;
	
	private String value = "";	
	private Metaset father = null;
	
	private ArrayList attributes = null;
	
	private ArrayList childs = null;
	
	public static final String SEPERATOR = "\\";
	
	private String encoding = "GB2312";
	
	
	public Metaset() {
		this("", "");
	}
	
	public Metaset(String name) {
		this("", name);
	}
	
	public Metaset(QName qName) {
		this(qName.getNameSpace(),qName.getName());
	}
	
	public Metaset(String namespace, String name) {
		this.namespace = namespace;
		this.name = name;
	}
	
	public static Metaset create(String path) throws Exception {
		Metaset results = MetasetParser.getInstance().parse(new FileInputStream(path));
		dealImport(results);
		return results;
	}
	
	private static void dealImport(Metaset current) {
				Collection importURL =
			current.selectors("definitions//import", "location");
		if (importURL != null) {
			for (Iterator iter = importURL.iterator(); iter.hasNext();) {
				String element = (String) iter.next();
				MetasetParser p = new MetasetParser();
				Metaset temp = null;
				try {
					temp = p.parse(new FileInputStream(element));
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				}
				if (temp != null) {
					Metaset tmp;
										if (temp.filter("definitions") != null) {
						tmp = (Metaset)temp.getChilds().get(0);
						dealImport(tmp);
					} else {
						tmp = temp;
						dealImport(tmp);
					}
					for (int j = 0; j < tmp.getChilds().size(); j++) {
						current.add((Metaset)tmp.getChilds().get(j));
					}
				}
			}
		}
	}
	
	public void setNamespace(String value) {
		namespace = value;
	}
	
	public String getNamespace() {
		return namespace;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public void setValue(String value) {
		this.value = value;
	}
	
	public String getValue() {
		return value;
	}
	
	public void setFather(Metaset father) {
		this.father = father;
	}
	
	public Metaset getFather() {
		return father;
	}
	
	public String getEncoding() {
		return encoding;
	}
	
	public void setEncoding(String encoding) {
		this.encoding = encoding;
	}
	
	public List getAttributes() {
		if (attributes==null) {
			attributes = new ArrayList();
		}
		return attributes;
	}
	
	public List getChilds() {
		if (childs==null) {
			childs = new ArrayList();
		}
		return childs;
	}
	
	public String toXML() {
 String result = "";
        String qName = "";
        if (name == "") {
            for (int j = 0; j < getChilds().size(); j++) {
                result += ((Metaset) getChilds().get(j)).toXML();             }
        } else {
            if (namespace != "") {
                qName = namespace + ":" + name;
            } else {
                qName = name;
            }
            result = "<" + qName;
            for (int i = 0; i < getAttributes().size(); i++) {
                Attribute attr = (Attribute) attributes.get(i);
                if (attr.getName() != "name") {                        if (attr.getValue() != null
                                && !attr.getValue().equals("")) {
                            result += " " + attributes.get(i).toString();
                        }
                } else {
                    result += " " + attributes.get(i).toString();
                }
            }
            if (getChilds().size() > 0) {
                result += ">\n";                 for (int j = 0; j < getChilds().size(); j++) {
                    result += ((Metaset) getChilds().get(j)).toXML();
                }
                result += "</" + qName + ">\n";             } else if (value != "") {
                result += ">";                 result += normalize(value) + "";                 result += "</" + qName + ">\n";             } else {
                result += "/>\n";             }
        }
        return result;
	}
	
    
    public String toXMLModel() {
        String result = "";
        String qName = "";
        if (name == "") {
            for (int j = 0; j < getChilds().size(); j++) {
                result += ((Metaset) getChilds().get(j)).toXMLModel();             }
        } else {
            if (namespace != "") {
                qName = namespace + ":" + name;
            } else {
                qName = name;
            }
            result = "<" + qName;
            for (int i = 0; i < getAttributes().size(); i++) {
                Attribute attr = (Attribute) attributes.get(i);
                                    if (attr.getName().equals("debugId")
                            || attr.getName().equals("breakPoint")) {                                                                    } else if (attr.getName().equals("name")){
                        if (attr.getValue() != null
                                && !attr.getValue().equals("")) {
                            result += " " + attributes.get(i).toString();
                        }
                    }
                                else {
                    result += " " + attributes.get(i).toString();
                }
            }
            if (getChilds().size() > 0) {
                result += ">\n";                 for (int j = 0; j < getChilds().size(); j++) {
                    result += ((Metaset) getChilds().get(j)).toXMLModel();
                }
                result += "</" + qName + ">\n";             } else if (value != "") {
                result += ">";                 result += normalize(value) + "";                 result += "</" + qName + ">\n";             } else {
                result += "/>\n";             }
        }
        return result;
    }
	
	public String toDocument() {
		if (encoding==null) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + toXML();
		}
		else {
			return "<?xml version=\"1.0\" encoding=\""+encoding+"\"?>" + toXML();
		}
	}
	
	
	public Metaset filter(String path) {
		StringTokenizer st = new StringTokenizer(path, SEPERATOR);
		Stack stack = new Stack();
		ArrayList resultList = new ArrayList();
		stack.push(this);
		while (st.hasMoreTokens()) {
			Stack tmp = new Stack();
			String str = st.nextToken();
			if (!str.trim().equals("*")) {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (str.trim().equals(".")
						|| str.equals(ss.getName())) {
						if (!st.hasMoreTokens()) {
							resultList.add(ss);
						} else {
							for (int i = 0; i < ss.getChilds().size(); i++) {
								tmp.push(ss.getChilds().get(i));
							}
						}
					}
				}
			} else {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (!st.hasMoreTokens()) {
						resultList.add(ss);
					} else {
						for (int i = 0; i < ss.getChilds().size(); i++) {
							tmp.push(ss.getChilds().get(i));
						}
					}
				}
			}
			stack = tmp;
		}
		if (resultList.isEmpty()) {
			return null;
		} else {
			Metaset result = new Metaset();
			for (int i = resultList.size() - 1; i >= 0; i--) {
				result.add((Metaset) resultList.get(i));
			}
			return result;
		}
	}
	
	public Metaset filter(String path, String an) {
		StringTokenizer st = new StringTokenizer(path, SEPERATOR);
		Stack stack = new Stack();
		ArrayList resultList = new ArrayList();
		stack.push(this);
		while (st.hasMoreTokens()) {
			Stack tmp = new Stack();
			String str = st.nextToken();
			if (!str.trim().equals("*")) {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (str.trim().equals(".")
						|| str.equals(ss.getName())) {
						if (!st.hasMoreTokens()) {
							for (int j = 0; j < ss.getAttributes().size(); j++) {
								Attribute p = (Attribute)ss.getAttributes().get(j);
								if (an.equals(p.getName())) {
									resultList.add(ss);
									break;
								}
							}
						} else {
							for (int i = 0; i < ss.getChilds().size(); i++) {
								tmp.push(ss.getChilds().get(i));
							}
						}
					}
				}
			} else {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (!st.hasMoreTokens()) {
						for (int j = 0; j < ss.getAttributes().size(); j++) {
							Attribute p = (Attribute)ss.getAttributes().get(j);
							if (an.equals(p.getName())) {
								resultList.add(ss);
								break;
							}
						}
					} else {
						for (int i = 0; i < ss.getChilds().size(); i++) {
							tmp.push(ss.getChilds().get(i));
						}
					}
				}
			}
			stack = tmp;
		}
		if (resultList.isEmpty()) {
			return null;
		} else {
									Metaset result = new Metaset("", "");
			for (int i = resultList.size() - 1; i >= 0; i--) {
				result.add((Metaset) resultList.get(i));
			}
			return result;
		}
	}
	
	public Metaset filter(String path, String an, String av) {
		StringTokenizer st = new StringTokenizer(path, SEPERATOR);
		Stack stack = new Stack();
		ArrayList resultList = new ArrayList();
		stack.push(this);
		while (st.hasMoreTokens()) {
			Stack tmp = new Stack();
			String str = st.nextToken();
			if (!str.trim().equals("*")) {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (str.trim().equals(".")
						|| str.equals(ss.getName())) {
						if (!st.hasMoreTokens()) {
							for (int j = 0; j < ss.getAttributes().size(); j++) {
								Attribute p = (Attribute)ss.getAttributes().get(j);
								if (an.equals(p.getName())
									&& av.equals(p.getValue())) {
									resultList.add(ss);
									break;
								}
							}
						} else {
							for (int i = 0; i < ss.getChilds().size(); i++) {
								tmp.push(ss.getChilds().get(i));
							}
						}
					}
				}
			} else {
				while (!stack.empty()) {
					Metaset ss = (Metaset) stack.pop();
					if (!st.hasMoreTokens()) {
						for (int j = 0; j < ss.getAttributes().size(); j++) {
							Attribute p = (Attribute)ss.getAttributes().get(j);
							if (an.equals(p.getName())
								&& av.equals(p.getValue())) {
								resultList.add(ss);
								break;
							}
						}
					} else {
						for (int i = 0; i < ss.getChilds().size(); i++) {
							tmp.push(ss.getChilds().get(i));
						}
					}
				}
			}
			stack = tmp;
		}
		if (resultList.isEmpty()) {
			return null;
		} else {
			Metaset result = new Metaset("", "");
			for (int i = resultList.size() - 1; i >= 0; i--) {
				result.add((Metaset) resultList.get(i));
			}
			return result;
		}
	}
	
	public String selector(String path) {
		Metaset tmp = filter(path);
		if (tmp != null && tmp.getChilds().size() > 0) {
			return ((Metaset)tmp.getChilds().get(0)).getName();
		}
		return null;
	}
	
	public Collection selectors(String path) {
		List list = new ArrayList();
		Metaset tmp = filter(path);
		if (tmp != null) {
			for (int i = 0; i < tmp.getChilds().size(); i++) {
				Metaset temp = (Metaset) tmp.getChilds().get(i);
				list.add(temp.getName());
			}
		}
		return list;
	}
	
	public String selector(String path, String an) {
		Metaset tmp = filter(path);
		if (tmp != null) {
			QName name = null;
			if (an.indexOf(":")>=0) {
				name = new QName(an);
			}
			for (int i = 0; i < tmp.getChilds().size(); i++) {
				Metaset temp = (Metaset) tmp.getChilds().get(i);
				for (int j = 0; j < temp.getAttributes().size(); j++) {
					Attribute p = (Attribute) temp.getAttributes().get(j);
					if (name!=null) {
						if (name.getNameSpace().equals(p.getNameSpace()) && name.getName().equals(p.getName())) {
							return p.getValue();
						}
					}
					else if (an.equals(p.getName())) {
						return p.getValue();
					}
				}
			}
		}
		return null;
	}
	
	public Collection selectors(String path, String an) {
		List result = new ArrayList();
		Metaset tmp = filter(path);
		if (tmp != null) {
			for (int i = 0; i < tmp.getChilds().size(); i++) {
				Metaset temp = (Metaset) tmp.getChilds().get(i);
				for (int j = 0; j < temp.getAttributes().size(); j++) {
					Attribute p = (Attribute) temp.getAttributes().get(j);
										if (an.equals("*")) {
						result.add(p.getName());
					} else if (an.equals(p.getName())) {
						result.add(p.getName());
					}
				}
			}
		}
		return result;
	}
	
	public void add(Attribute attribute) {
		if (!getAttributes().contains(attribute)) {
			getAttributes().add(attribute);
		}
	}
	
	public void add(Metaset child) {
		getChilds().add(child);
	}
	
	public void add(String path, Metaset child) {
		Metaset result = filter(path);
		if (result != null && result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(child);
		}
	}
	
	public void add(String path, String an, Metaset child) {
		Metaset result = filter(path, an);
		if (result != null & result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(child);
		}
	}
	
	public void add(String path, String an, String av, Metaset child) {
		Metaset result = filter(path, an, av);
		if (result != null && result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(child);
		}
	}
	
	public void add(String path, Attribute attribute) {
		Metaset result = filter(path);
		if (result != null && result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(attribute);
		}
	}
	
	public void add(String path, String an, Attribute attribute) {
		Metaset result = filter(path, an);
		if (result != null && result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(attribute);
		}
	}
	
	public void add(
		String path,
		String an,
		String av,
	Attribute attribute) {
		Metaset result = filter(path, an, av);
		if (result != null && result.getChilds().size() > 0) {
			((Metaset)result.getChilds().get(0)).add(attribute);
		}
	}
	
	public boolean remove(Attribute attribute) {
		if (getAttributes().contains(attribute)) {
			return attributes.remove(attribute);
		}
		return false;
	}
	
	public boolean remove(Metaset ss) {
		if (getChilds().contains(ss)) {
			return getChilds().remove(ss);
		}
		return false;
	}
	
	public void remove(String path) {
		Metaset result = filter(path);
		if ((result != null) && (result.getChilds().size() > 0)) {
			for (int i = 0; i < result.getChilds().size(); i++) {
				((Metaset)result.getChilds().get(i)).getFather().remove((Metaset)result.getChilds().get(i));
			}
		}
	}
	
	public void remove(String path, String an) {
		Metaset result = filter(path, an);
		if ((result != null) && (result.getChilds().size() > 0)) {
			for (int i = 0; i < result.getChilds().size(); i++) {
				((Metaset)result.getChilds().get(i)).getFather().remove((Metaset)result.getChilds().get(i));
			}
		}
	}
	
	public void remove(String path, String an, String av) {
		Metaset result = filter(path, an, av);
		if ((result != null) && (result.getChilds().size() > 0)) {
			for (int i = 0; i < result.getChilds().size(); i++) {
				((Metaset)result.getChilds().get(i)).getFather().remove((Metaset)result.getChilds().get(i));
			}
		}
	}
	
	public Object clone() throws CloneNotSupportedException {
		Metaset result = (Metaset) super.clone();
		if (attributes!=null) {
		result.attributes = new ArrayList();
		for (int i=0; i<this.attributes.size(); i++) {
			Attribute attr = (Attribute)this.attributes.get(i);
			result.attributes.add(attr.clone());
		}
		}
		if (childs!=null) {
		result.childs = new ArrayList();
		for (int i=0; i<this.childs.size(); i++) {
			Metaset ss = (Metaset) ((Metaset) this.childs.get(i)).clone();
			ss.setFather(result);
			result.childs.add(ss);
		}
		}
						return result;
	}
	
	public Metaset car() {
		if (getChilds().size() > 0) {
			return (Metaset)getChilds().get(0);
		}
		return null;
	}
		public Metaset car(String path) {
		return null;
	}
	
		public Metaset cdr(String path) {
		return null;
	}
	
	
	public Metaset cdr() {
		if (getChilds().size() > 0) {
			getChilds().remove(0);
		}
		return null;
	}
	
	public int getHeight() {
		if (this.childs.size() == 0) {
			return 0;
		}
		int height = 0;
		for (int i = 0; i < childs.size(); i++) {
			Metaset ss = (Metaset) getChilds().get(i);
			int tmp = ss.getHeight();
			if (tmp > height) {
				height = tmp;
			}
		}
		return height + 1;
	}
	
	public int getLeafCount() {
		if (this.childs.size() == 0) {
			return 1;
		}
		int count = 0;
		for (int i = 0; i < childs.size(); i++) {
			Metaset ss = (Metaset) childs.get(i);
			count += ss.getLeafCount();
		}
		return count;
	}
	
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		} else {
			Metaset other = (Metaset) o;
			boolean result = true;
			result =
				this.name.equals(other.name)
					&& this.namespace.equals(other.namespace)
					&& ((value==null && other.value==null)||this.value.equals(other.value))
										&& (this.getAttributes().size() == other.getAttributes().size())
					&& (this.getChilds().size() == other.getChilds().size());
			if (!result) {
				return result;
			}
			for (int i = 0; i < this.getAttributes().size(); i++) {
				result =
					result
						&& this.getAttributes().get(i).equals(other.getAttributes().get(i));
				if (!result) {
					return result;
				}
			}
			for (int i = 0; i < this.getChilds().size(); i++) {
								System.out.println("ServicesSet.equals()");
				result =
					result && ((Metaset)this.getChilds().get(i)).equals(other.getChilds().get(i));
				if (!result) {
					return result;
				}
			}
			return true;
		}
	}
	
	public boolean isEmpty() {
		return getChilds().size() == 0;
	}
        
    public int getServicesSetPosition(Metaset newSs) {
        int i = this.getChilds().indexOf(newSs);
        return i;
    }
    
    public void insert(Metaset child, int position) {
        Metaset temp = null;
        getChilds().add(temp);
        for (int i = getChilds().size() - 2; i >= position; i--) {
            temp = (Metaset) getChilds().get(i);
            if (i - 1 >= 0) {
                getChilds().set(i, getChilds().get(i - 1));
            }
            getChilds().set(i + 1, temp);
        }
        getChilds().set(position, child);
    }
    
    private static String normalize (String s) {
        StringBuffer str = new StringBuffer();
        int len = (s != null) ? s.length() : 0;
        for (int i = 0; i < len; i++) {
            char ch = s.charAt(i);
            switch (ch) {
                case '<': {
                    str.append("&lt;");
                    break;
                }
                case '>': {
                    str.append("&gt;");
                    break;
                }
                case '&': {
                    str.append("&amp;");
                    break;
                }
                case '"': {
                    str.append("&quot;");
                    break;
                }
                case NL: {
                    if (i > 0) {
                        char lastChar = str.charAt(str.length() - 1);
                        if (lastChar != CR) {
                            str.append(LS);
                        }
                        else {
                            str.append(NL);
                        }
                    }
                    else {
                        str.append(LS);
                    }
                    break;
                }
                default: {
                    str.append(ch);
                }
            }
        }
        return (str.toString());
    }
    
    public static final char NL = '\n';
    public static final char CR = '\r';
    
    public static final String LS = System.getProperty("line.separator",
        (new Character(NL)).toString());
}
