
package org.act.services.thread;

public abstract class Terminatable implements Runnable {
	
		public static final int RUNNING = 3;
		public static final int STOPPING = 1;
	public static final int STOPPED = 0;
	
	private int state = STOPPED;
	
	
	public void run() {
						start();
		setState(RUNNING);
		while (getState()==RUNNING) {
			try {
				process();
			} catch (ObjectOperationException e) {
				e.printStackTrace();
			}
		}
				stop();
		setState(STOPPED);
	}
	
	abstract protected void process() throws ObjectOperationException;
	
	protected void prePorocessStopping() throws ObjectOperationException{};
	
	protected void start(){}
	
	protected void stop(){}
	
	
	public synchronized final int getState() {
		return state;
	}
	
	
	protected synchronized final void setState(int state) {
		this.state = state;
	}
	
	
	public final void terminate() {
		try {
			prePorocessStopping();
		} catch (ObjectOperationException e) {
			e.printStackTrace();
		}
		setState(STOPPING);
	}
}
