
package org.act.services.wsrm;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Random;
import java.util.Timer;
import javax.swing.Action;
import org.act.message.timer.ClearRecvRMCacheTimerTask;
import org.act.message.timer.ClearRecvRMReplyCacheTimerTask;
import org.act.message.timer.ClearSendRMCacheTimerTask;
import org.act.message.timer.ClearSendRMReplyCacheTimerTask;
import org.act.message.timer.GroupReSendTask;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.metaset.QName;
import org.act.services.IMessageContext;
import org.act.services.ITransportContext;
import org.act.services.ITransportContext.RequestTransportContext;
import org.act.services.ITransportContext.ResponseTransportContext;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.http.HTTPURLResponseTransportContext;
import org.act.services.runtime.Application;
import com.sun.jndi.cosnaming.IiopUrl.Address;

public class P2PRMP  implements IP2PRMP {
	
	
	
	private ArrayList SendRMCache;
	private ArrayList ReceiveRMReplyCache;
	private ArrayList ReceiveRMCache;
	private ArrayList SendRMReplyCache;
	private int MaxCacheCapacity;
	
	
	private Timer myCRCTimer1  = null;
	private Timer myCRRCTimer2 = null;
	private Timer myCSCTimer3  = null;
	private Timer myCSRCTimer4 = null;
	private ClearRecvRMCacheTimerTask      myCRCTimerTask  = null;
	private ClearRecvRMReplyCacheTimerTask myCRRCTimerTask = null;
	private ClearSendRMCacheTimerTask      myCSCTimerTask  = null;
	private ClearSendRMReplyCacheTimerTask myCSRCTimerTask = null;
	
	 
	
	private Date ExpiryTime;
	private boolean ReplyPatternValueResponse;
	private boolean ReplyPatternValueCallback;
	private boolean ReplyPatternValuePoll;
	private Date GroupExpiryTime;
	private int GroupMaxIdleDuration;
	
	private boolean GuaranteedDelivery;
	private boolean NoDuplicateDelivery;
	private boolean ExactlOnceDelivery;
	private boolean OrderedDelivery;
	
	public final int StateOpen  = 0;
	public final int StateClose = 1;
	private int rmpState;
	
		public final int ReceivingRMP = 0;
	public final int SendingRMP   = 1;
	
	private static P2PRMP instance = null;
	
	private static Random random = new Random(129304901243092394L);
	
	
	
	public static P2PRMP getInstance() {
	if ( instance == null ) {
		instance = new P2PRMP();
	}
	return instance;
	}
	
	public P2PRMP() {
	super();
	init();
	}	
	
	public void init() {
	initCaches();
	initRMAgreementsRM();
	initRMAgreementsGroup();
	initRMAgreementsDelivery();
	initRmpState();
	}
	public void initCaches() {
		this.SendRMCache = new ArrayList();
	this.ReceiveRMReplyCache = new ArrayList();
	this.ReceiveRMCache = new ArrayList();
	this.SendRMReplyCache = new ArrayList();
	this.MaxCacheCapacity = WSRMUtil.MaxCacheCapacity;
	if (WSRMUtil.SupportTimerTask) {
		try {
	    		    		    	myCRCTimer1  = new Timer(true);
	    	myCRRCTimer2 = new Timer(true);
	    	myCSCTimer3  = new Timer(true);
	    	myCSRCTimer4 = new Timer(true);
	    	myCRCTimerTask  = new ClearRecvRMCacheTimerTask();
	    	myCRRCTimerTask = new ClearRecvRMReplyCacheTimerTask();
	    	myCSCTimerTask  = new ClearSendRMCacheTimerTask();
	    	myCSRCTimerTask = new ClearSendRMReplyCacheTimerTask();
				    	myCRCTimer1.schedule (myCRCTimerTask,  100000, 600000);
	    	myCRRCTimer2.schedule(myCRRCTimerTask, 100000, 600000);
	    	myCSCTimer3.schedule (myCSCTimerTask,  100000, 600000);
	    	myCSRCTimer4.schedule(myCSRCTimerTask, 100000, 600000);
    	} catch (IllegalArgumentException arg) {
    		arg.printStackTrace();
    	} catch (IllegalStateException state) {
    		state.printStackTrace();
    	}
	}
	}
	
	public void initRMAgreementsRM() {
	this.ExpiryTime = new Date();
	SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
        try {
    	this.ExpiryTime = SDF.parse("2008-10-10T01:10:10-01:00");
    } catch (ParseException ex) {
    	    	System.out.println("P2PRMP.initRMAgreementsRM(): RMP init ExpiryTime Error");
    }
    this.ReplyPatternValueResponse = true;
	this.ReplyPatternValueCallback = true;
	this.ReplyPatternValuePoll = true;
	}
	public void initRMAgreementsGroup() {
	this.GroupExpiryTime = new Date();
	SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
        try {
    	this.GroupExpiryTime = SDF.parse("2008-10-10T01:10:10-01:00");
    } catch (ParseException ex) {
    	    	System.out.println("P2PRMP.initRMAgreementsGroup(): RMP init GroupExiryTime Error");
    }
	this.GroupMaxIdleDuration = 100;
	}
	public void initRMAgreementsDelivery() {
	this.GuaranteedDelivery = true;
	this.NoDuplicateDelivery = true;
	this.ExactlOnceDelivery = true;
	this.OrderedDelivery = true;
	}
	
	public void initRmpState() {
	this.rmpState = StateOpen;
	}
	
	public ArrayList getSendRMCache() {
	return SendRMCache;
	}
	
	public ArrayList getReceiveRMReplyCache() {
	return ReceiveRMReplyCache;
	}
	
	public ArrayList getReceiveRMCache() {
	return ReceiveRMCache;
	}
	
	public ArrayList getSendRMReplyCache() {
	return SendRMReplyCache;
	}
	
	
	
	public void ClearSendRMCache() {
	
	Group g = null;
	int index = 0;
	while ( ( index >= 0 ) && ( index < this.SendRMCache.size() ) ) {
		g = (Group) this.SendRMCache.get(index);
		if ( g.Removed == g.getState() ) {
			this.SendRMCache.remove(index);
		}
		else {
			index ++;
		}
	}
	}
	
	public void ClearReceiveRMCache() {
	
	Group g = null;
	int index = 0;
	while ( ( index >= 0 ) && ( index < this.ReceiveRMCache.size() ) ) {
		g = (Group) this.ReceiveRMCache.get(index);
		if ( g.Removed == g.getState() ) {
			this.ReceiveRMCache.remove(index);
		}
		else {
			index ++;
		}
	}
	}
	
	public void ClearReceiveRMReplyCache() {
	
	this.ReceiveRMReplyCache.clear();
	}
	
	public void ClearSendRMReplyCache() {
	
	Group g = null;
	ReliableMessage rm = null;
	int i = 0;
	while ( ( i >=0 ) && ( i < SendRMReplyCache.size() ) ) {
		g = (Group) SendRMReplyCache.get(i);
		int index = 0;
		while ( ( index >= 0 ) && ( index < g.AL.size() ) ) {
			rm = (ReliableMessage) g.AL.get(index);
			if ( rm.UndeliveredWait != rm.getState() ) {
								g.removeMessage(index);
			} else {
				index ++;
			}
		}
		if ( 0 == g.AL.size() ) {
			SendRMReplyCache.remove(i);
		} else {
			i ++;
		}
	}
	}
	
	
	public void removeGroup(String groupId) {
		try {
		removeGroupFromReceiveRMCache(groupId);
		removeGroupFromSendRMCache(groupId);
		removeGroupFromSendRMReplyCache(groupId);
		removeGroupFromReceiveRMReplyCache(groupId);
	} catch (Exception e) {
		e.printStackTrace();
		System.out.println("P2PRMP.removeGroup(): remove error occurs");
	}
	}
	
	
	public void removeGroupFromReceiveRMCache(String groupId) {
	try {
		int index = GroupHasExisted(this.ReceiveRMCache, groupId);
		if ( -1 != index ) {
						Group g = (Group)this.ReceiveRMCache.get(index);
			
			g.gReSendTask.cancel();
			this.ReceiveRMCache.remove(index);
		} else {
			System.out.println("P2PRMP.removeGroupFromReceiveRMCache(): groupId is not existed");
		}
	} catch (Exception e) {
		e.printStackTrace();
		System.out.println("P2PRMP.removeGroupFromReceiveRMCache(): remove error occurs");
	}
	}
	
	public void removeGroupFromSendRMCache(String groupId) {
	try {
		int index = GroupHasExisted(this.SendRMCache, groupId);
		if ( -1 != index ) {
						Group g = (Group)this.SendRMCache.get(index);
			g.gReSendTask.cancel();
			this.SendRMCache.remove(index);
		} else {
			System.out.println("P2PRMP.removeGroupFromSendRMCache(): groupId is not existed");
		}
	} catch (Exception e) {
		e.printStackTrace();
		System.out.println("P2PRMP.removeGroupFromSendRMCache(): remove error occurs");
	}
	}
	
	public void removeGroupFromSendRMReplyCache(String groupId) {
	try {
		int index = GroupHasExisted(this.SendRMReplyCache, groupId);
		if ( -1 != index ) {
						Group g = (Group)this.SendRMReplyCache.get(index);
			g.gReSendTask.cancel();
			this.SendRMReplyCache.remove(index);
		} else {
			System.out.println("P2PRMP.removeGroupFromSendRMReplyCache(): groupId is not existed");
		}
	} catch (Exception e) {
		e.printStackTrace();
		System.out.println("P2PRMP.removeGroupFromSendRMReplyCache(): remove error occurs");
	}
	}
	
	public void removeGroupFromReceiveRMReplyCache(String groupId) {
	try {
		int index = GroupHasExisted(this.ReceiveRMReplyCache, groupId);
		if ( -1 != index ) {
						Group g = (Group)this.ReceiveRMReplyCache.get(index);
			g.gReSendTask.cancel();
			this.ReceiveRMReplyCache.remove(index);
		} else {
			System.out.println("P2PRMP.removeGroupFromReceiveRMReplyCache(): groupId is not existed");
		}
	} catch (Exception e) {
		e.printStackTrace();
		System.out.println("P2PRMP.removeGroupFromReceiveRMReplyCache(): remove error occurs");
	}
	}
	public int getMaxCacheCapacity() {
	return MaxCacheCapacity;
	}
	
	public void setMaxCacheCapacity(int capacity) {
	this.MaxCacheCapacity = capacity;
	}
	
	public void AddGroup(Group g, ArrayList cache) {
	cache.add(g);
	}
	
	public void AddGroupByIndex(Group g, int index, ArrayList cache) {
	cache.add(index, g);
	}
	
	public Group getGroupByIndex(int index, ArrayList cache) {
	return (Group)(cache.get(index));
	}
	
	public boolean IfCacheFull(ArrayList cache) {
	if ( cache.size() == MaxCacheCapacity ) return true;
	else return false;
	}
	
	public int getGroupSize(ArrayList cache, int index, Group g) {
	return ( (Group) (cache.get(index)) ).getSize();
	}
	
	public void clear(ArrayList cache) {
	cache.clear();
	}
	
	public Date getExpriyTime() {
	return ExpiryTime;
	}
	
	public void setExpiryTime(Date expirytime) {
	this.ExpiryTime = expirytime;
	}
	
	public boolean getReplyPatternValueRespone() {
	return ReplyPatternValueResponse = true;
	}
	
	public void setReplyPatternValueResponse(boolean b) {
	this.ReplyPatternValueResponse = true;
	}
	
	public boolean getReplyPatternValueCallback() {
	return ReplyPatternValueCallback = true;
	}
	
	public void setReplyPatternValueCallback(boolean b) {
	this.ReplyPatternValueCallback = true;
	}
	
	public boolean getReplyPatternValuePoll() {
	return ReplyPatternValuePoll = true;
	}
	
	public void setReplyPatternValuePoll(boolean b) {
	this.ReplyPatternValuePoll = true;
	}
	public Date getGroupExpiryTime() {
	return GroupExpiryTime;
	}
	
	public void setGroupExpiryTime(Date date) {
	this.GroupExpiryTime = date;
	}
	
	public int getGroupMaxIdleDuration() {
	return GroupMaxIdleDuration;
	}
	
	public void setGroupMaxIdleDuration(int seconds) {
	this.GroupMaxIdleDuration = seconds;
	}
	
	public boolean getGuaranteedDelivery() {
	return GuaranteedDelivery;
	}
	
	public void setGuaranteedDelivery(boolean b) {
	this.GuaranteedDelivery = b;
	}
	
	public boolean getNoDuplicateDelivery() {
	return NoDuplicateDelivery;
	}
	
	public void setNoDuplicateDelivery(boolean b) {
	this.NoDuplicateDelivery = b;
	}
	
	public boolean getExactlOnceDelivery() {
	return ExactlOnceDelivery;
	}
	
	public void setExactlOnceDelivery(boolean b) {
	this.ExactlOnceDelivery = b;
	}
	
	public boolean getOrderedDelivery() {
	return OrderedDelivery;
	}
	
	public void setOrderedDelivery(boolean b) {
	this.OrderedDelivery = b;
	}	
	
	public int getRmpState() {
	return rmpState;
	}
	
	public void setRmpState(int state) {
	this.rmpState = state;
	}
	
	public int GroupHasExisted(ArrayList grouplist, String groupId) {
	int index = -1;
	Group g;
	if (groupId == null || groupId == "") {
		return index;
	} else {
		for ( int circle = 0 ; circle < grouplist.size() ; circle ++ ) {
			g = (Group)grouplist.get(circle);
			if ( groupId.equals(g.getGroupId()) ) {
				index = circle;
				break;
			}
		}
	}
	return index;
	}
		public String testIfRmAgreementBeSpot(String result, ReliableMessage rm) {
		result = testIfRmAgreementBeSpotTestRM(result, rm);
	if ( "Right".equals(result) ) {
		result = testIfRmAgreementBeSpotTestGroup(result, rm);
	}
	return result;
	}
	public String testIfRmAgreementBeSpotTestRM(String result, ReliableMessage rm) {
				if ( rm.getExpiryTime().getTime() > this.ExpiryTime.getTime() ) {
			result = "FeatureNotSupported: the RMP's Current ExpiryTime is " + this.GroupExpiryTime.toString()
						+ " the RM's ExpiryTime is " + rm.getExpiryTime().getTime()
						+ " the RM's ExpiryTime is larger than the RMP's Current supported ExpiryTime";
		}
		if ( "Response".equals(rm.getReplyPatternValue() ) && !this.ReplyPatternValueResponse ) {
			result = "FeatureNotSupported: the Response RM-Reply Pattern is not supported by RMP";
		}
		if ( "Callback".equals(rm.getReplyPatternValue() ) && !this.ReplyPatternValueCallback ) {
			result = "FeatureNotSupported: the Callback RM-Reply Pattern is not supported by RMP";
		}
		if ( "Poll".equals(rm.getReplyPatternValue() ) && !this.ReplyPatternValuePoll ) {
			result = "FeatureNotSupported: the Poll RM-Reply Pattern is not supported by RMP";
		}
		return result;
	}
	public String testIfRmAgreementBeSpotTestGroup(String result, ReliableMessage rm) {
		String sGroupMaxIdleDuration = rm.getIMessageContext().getRequestServices().selector("Envelope" +
			"\\Header\\Request\\MessageId\\SequenceNum", "groupMaxIdleDuration");
	String sGroupExpiryTime = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
			"\\Request\\MessageId\\SequenceNum", "groupExpiryTime");
	if ( sGroupMaxIdleDuration!= null ) {
		int rmDuration = WSRMUtil.stringParseInteger(sGroupMaxIdleDuration);
		if ( rmDuration > this.GroupMaxIdleDuration ) {
			result = "FeatureNotSupported: the RMP's Current groupMaxIdleDuration is "
					+ this.GroupMaxIdleDuration + " the RM's GroupMaxIdleDuration is " + rmDuration
					+ " the RM's GroupMaxIdleDuration is larger than the RMP's Current supported " +
							"GroupMaxIdleDuration";
		}
	}
	if ( sGroupExpiryTime != null ) {
		Date rmGroupExpiryTime = WSRMUtil.stringParseDate(sGroupExpiryTime);
		if ( rmGroupExpiryTime.getTime() > this.GroupExpiryTime.getTime() ) {
			result = "FeatureNotSupported: the RMP's Current GroupExpiryTime is " 
						+ this.GroupExpiryTime.toString()
						+ " the RM's GroupExpiryTime is " + rm.getExpiryTime().getTime()
						+ " the RM's GroupExpiryTime is larger than the RMP's Current supported GroupExpiryTime";
		}
	}
	if ( !this.GuaranteedDelivery  && rm.getGuaranteedDelivery() ) {
		result = "FeatureNotSupported: the GuaranteedDelivery is not supported by RMP";
	}
	if ( !this.NoDuplicateDelivery  && rm.getNoDuplicateDelivery() ) {
		result = "FeatureNotSupported: the NoDuplicateDelivery is not supported by RMP";
	}
	if ( !this.ExactlOnceDelivery && rm.getExactlOnceDelivery() ) {
		result = "FeatureNotSupported: the ExactlOnceDelivery is not supported by RMP";
	}
	if ( !this.OrderedDelivery && rm.getOrderedDelivery() ) {
		result = "FeatureNotSupported: the OrderedDelivery is not supported by RMP";
	}
	return result;
	}
	
	
	public ArrayList SoapIN(IMessageContext obj){
	ArrayList result = new ArrayList();
	ReliableMessage rm = new ReliableMessage();
	rm.setIMessageContext(obj);
	
		
		rm.initSetRequest();
	
		String sTest = rm.testWhetherIsRM("IN");
	if ( "Right".equals(sTest) ) {
				MessageFormatFault(rm);
		if ( "Right".equals( rm.getMessageFormatState() ) ) { 						if (rm.RequestType == rm.getType()) {
				sTest = testIfRmAgreementBeSpot(sTest, rm);
			}
									if (rm.ResponseType == rm.getType()) {
				Metaset NonSequenceReply = 
							rm.getIMessageContext().getRequestServices().
							filter("Envelope\\Header\\Response\\NonSequenceReply");
			    if (NonSequenceReply != null) {
			    	rm.setGroupId( rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
			    					"Response\\NonSequenceReply", "groupId") );
			    } else {
			    	rm.setGroupId( rm.getIMessageContext().getRequestServices().selector("Envelope\\Header\\" +
									"Response\\SequenceReplies", "groupId") );
			    }
			}
			if ( "Right".equals(sTest) ) {					result = SoapINRmByType(rm);
			} else { 				FaultFeatureNotSupport(rm);
			}
		} else { 						System.out.println("P2PRMP.SoapIN(): " + rm.getMessageFormatState());
			FaultMessageFormatFault(rm);
		}
	} else { 		SoapINNormalMessage(result, rm);
	}
	return result;
	}
	
	private void SoapIN_InitWSA(ReliableMessage rm) {
	Metaset envelope = (Metaset) rm.getIMessageContext().getRequestServices();
	Metaset header = (Metaset)(envelope.filter(".\\Header"));
	if (header == null) {
		header = new Metaset("SOAP-ENV", "Header");
		header.add(new Attribute(new QName("xmlns", "wsa"), 
			"http://www.w3.org/2005/03/addressing"));
	}
	Metaset wsamID = new Metaset("wsa", "MessageID");
	wsamID.add(new Attribute(new QName("SOAP-ENV", "mustUnderstand"), "0"));
	wsamID.setValue("uuid:cdf8f560-88c9-11da-a8fc-d268ae1d4e46");
	header.add(wsamID);
	
	Metaset soapto = new Metaset("wsa", "To");
	soapto.add(new Attribute(new QName("SOAP-ENV", "mustUnderstand"), "0"));
	soapto.setValue("http://localhost:8181/axis/services/DataAccess");
	header.add(soapto);
	
	Metaset soapfrom = new Metaset("wsa", "From");
	soapfrom.add(new Attribute(new QName("SOAP-ENV", "mustUnderstand"), "0"));
	Metaset Address = new Metaset("wsa", "Address");
	Address.setValue("http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous");
	soapfrom.add(Address);
	header.add(soapfrom);
	Metaset body = new Metaset("Body");
	body = (Metaset)envelope.getChilds().get(0);
	envelope.remove(body);
		envelope.add("Envelope\\", header);
	envelope.add(body);
	}
	public void MessageFormatFault(ReliableMessage rm) {
	try {
		rm.testMessageFormatFault();
	} catch (TestMessageFormatException tmfe) {
				System.out.println("P2PRMP.rmpMessageFormatFault(): Error of testMessageFormatFault");
	}
	}
	public void FaultFeatureNotSupport(ReliableMessage rm) {
	
	if ( !IfCacheFull(this.SendRMReplyCache) ) { 		FeatureNotSupportCacheNotFull(rm);
	} else { 						System.out.println("P2PRMP.rmpFaultFeatureNotSupport(): Do nothing and just throw away the RM ");
	}
	}
	public void FaultCacheFull(ReliableMessage rm, boolean isSender) {
	 
		rm.setMessageFormatState("MessageProcessingFailure: The number of buffered requests " +
			"exceeded the maximum limit");
	rm = rm.setFaultResponse(rm);
		Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
			getResponseServices().filter(".\\Body") ).getChilds().get(0);
	Metaset Fault = new Metaset("Fault");
	Metaset Code  = new Metaset("Code");
	Metaset Value = new Metaset("Value");
	if ( isSender ) {
		Value.setValue("soap12:Sender");
	} else {
		Value.setValue("soap12:Receiver");
	}
	Code.add(Value);
	Fault.add(Code);
	Body.add(Fault);
		String groupId = rm.getGroupId();
	if ( isSender ) {
		int index = GroupHasExisted(this.ReceiveRMReplyCache, groupId);
		if ( -1 != index ) { 			Group g = (Group)this.ReceiveRMReplyCache.get(index);
			g.AL.add(rm);
		} else {				Group g = new Group();
			g.AL.add(rm);
			this.ReceiveRMReplyCache.add(g);
		}
		rm.setState(rm.SentAndNotifyFault);
	} else {
		int index = GroupHasExisted(this.SendRMReplyCache, groupId);
		if ( -1 != index ) { 			Group g = (Group)this.SendRMReplyCache.get(index);
			g.AL.add(rm);
		} else {				Group g = new Group();
			g.AL.add(rm);
			this.SendRMReplyCache.add(g);
		}
		rm.setState(rm.UndeliveredFault);
	}
	}
	public void FeatureNotSupportCacheNotFull(ReliableMessage rm) {
		rm.setMessageFormatState("FeatureNotSupported: The feature sender required " +
			"is not supported by the Receiving RMP");
	rm = rm.setFaultResponse(rm);
		Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
			getResponseServices().filter(".\\Body") ).getChilds().get(0);
	Metaset Fault = new Metaset("Fault");
	Metaset Code  = new Metaset("Code");
	Metaset Value = new Metaset("Value");
	Value.setValue("soap12:Receiver");
	Code.add(Value);
	Fault.add(Code);
	Body.add(Fault);
		String groupId = rm.getGroupId();
	int index = GroupHasExisted(this.SendRMReplyCache, groupId);
	if ( -1 != index ) { 		Group g = (Group)this.SendRMReplyCache.get(index);
		g.AL.add(rm);
	} else {			Group g = new Group();
		g.AL.add(rm);
		this.SendRMReplyCache.add(g);
						rm.getIMessageContext().setRequestServices(null);
				IObjectPool transportOutputPool = Application.getRuntime().
											getObjectPool("transport",IObjectPool.OUT_MODE);
		synchronized (transportOutputPool) {
			while (transportOutputPool.full()) {
				try {
					transportOutputPool.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			ITransportContext.ResponseTransportContext rtc = 
				rm.getIMessageContext().getResponseTransportContext();
			rtc.setContent(rm.getIMessageContext().getResponseServices());
			rtc.setAttachments(rm.getIMessageContext().getResponseAttachments());
			if (Application.isDebug()) {
				System.out.println("Message Layer(Output):");
				System.out.println(rm.getIMessageContext().getResponseServices().toDocument());
			}
			transportOutputPool.put(rtc);
			transportOutputPool.notifyAll();
		}
	}
	rm.setState(rm.UndeliveredFault);
	}
	public void FaultMessageFormatFault(ReliableMessage rm) {
	if ( !IfCacheFull(this.SendRMReplyCache) ) { 	
	 	
	FaultMessageFormatAndCacheNotFull(rm);
	} else { 						
				
				
		System.out.println("P2PRMP.rmpFaultMessageFormatFault(): Do nothing and just throw away the RM ");
	}
	}
	public void FaultMessageFormatAndCacheNotFull(ReliableMessage rm) {
			rm = rm.setFaultResponse(rm);
		Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
			getResponseServices().filter(".\\Body") ).getChilds().get(0);
	Metaset Fault = new Metaset("Fault");
	Metaset Code  = new Metaset("Code");
	Metaset Value = new Metaset("Value");
	Value.setValue("soap12:Sender");
	Code.add(Value);
	Fault.add(Code);
	Body.add(Fault);
		String groupId = rm.getGroupId();
	int index = GroupHasExisted(this.SendRMReplyCache, groupId);
	if ( -1 != index ) { 		Group g = (Group)this.SendRMReplyCache.get(index);
		g.AL.add(rm);
	} else {			Group g = new Group();
		g.AL.add(rm);
		this.SendRMReplyCache.add(g);
	}
	rm.setState(rm.UndeliveredFault);
	}
	public void SoapINNormalMessage(ArrayList result, ReliableMessage rm) {
		rm.setMessageFormatState("Not a WS-R 1.1 supported Reliable Message");
	result.add(rm);
	}
	public synchronized ArrayList SoapINRmByType(ReliableMessage rm) {
	ArrayList result = new ArrayList();
	int type = rm.getType();
	
	if ( rm.InitType == type ) {			result.add(rm);
	} else if ( rm.RequestType == type ) {					ClearReceiveRMCache();
		SoapINRmRequest(rm);
		result = Deliver();
	} else if ( rm.ResponseType == type ) {					ClearReceiveRMReplyCache();
		SoapINRmResponse(rm);
		result = Notify();
	} else if ( rm.RequestResponseType == type ) {			
		System.out.println("P2PRMP.rmpProcessSoapRequestRmByType(): The way can not be reached now");
		result = null;
	} else if ( rm.PollRequestType ==  type ) { 				ClearReceiveRMCache();
		result = SoapINRmPollRequest(rm);
	} else {			System.out.println("P2PRMP.rmpProcessSoapRequestRmByType(): Error impossible path");
	}
	return result;
	}
	public void SoapINRmRequest(ReliableMessage rm) {		if ( !IfCacheFull(this.ReceiveRMCache) ) { 		String groupId = rm.getGroupId();
		int index = GroupHasExisted(this.ReceiveRMCache, groupId);
		if ( -1 != index ) { 			SoapINRmRequestGroupExisted(rm, index);
		} else {				SoapINRmRequestNewGroup(rm);
		}
	} else { 						FaultCacheFull(rm, false);
	}
	}
	public void SoapINRmRequestGroupExisted(ReliableMessage rm, int index) {
	Group g = (Group)this.ReceiveRMCache.get(index);
		g.stateUpdate(g.ReceivingRMP);
	if ( g.getState() == g.Running ) {			if ( "Right".equals( g.rmMatchGroup(rm) ) ) { 			if ( !"Right".equals( g.addMessage(rm) ) ) {
				if ( "SendRMReplyCache".equals( g.addMessage(rm) ) ) {	
					 					
					FaultPermanentProcessingFailure(rm);
				} else {
										FaultPermanentProcessingFailure(rm);
				}
			} else {					SoapINRmRequestGroupExistedUpdateGroupTime(rm, g);
			}
		} else {				 
			FaultPermanentProcessingFailure(rm);
		}
	} else {							FaultGroupAborted(rm);
	}
	}
	public void FaultPermanentProcessingFailure(ReliableMessage rm) {
				rm.setMessageFormatState("PermanentProcessingFailure: Message Delivery failures");
	rm = rm.setFaultResponse(rm);
		Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
			getResponseServices().filter(".\\Body") ).getChilds().get(0);
	Metaset Fault = new Metaset("Fault");
	Metaset Code  = new Metaset("Code");
	Metaset Value = new Metaset("Value");
	Value.setValue("soap12:Receiver");
	Code.add(Value);
	Fault.add(Code);
	Body.add(Fault);
		String groupId = rm.getGroupId();
	int index = GroupHasExisted(this.SendRMReplyCache, groupId);
	if ( -1 != index ) { 		Group g = (Group)this.SendRMReplyCache.get(index);
		g.AL.add(rm);
	} else {			Group g = new Group();
		g.AL.add(rm);
		this.SendRMReplyCache.add(g);
	}
	rm.setState(rm.UndeliveredFault);
	}
	
	public void FaultGroupAborted(ReliableMessage rm) {
				rm.setMessageFormatState("GroupAborted: Message delivery failures " +
			"for the reason of Group 'Completed' or 'Closed' or 'Removed'");
	rm = rm.setFaultResponse(rm);
		Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
			getResponseServices().filter(".\\Body") ).getChilds().get(0);
	Metaset Fault = new Metaset("Fault");
	Metaset Code  = new Metaset("Code");
	Metaset Value = new Metaset("Value");
	Value.setValue("soap12:Receiver");
	Code.add(Value);
	Fault.add(Code);
	Body.add(Fault);
		String groupId = rm.getGroupId();
	int index = GroupHasExisted(this.SendRMReplyCache, groupId);
	if ( -1 != index ) { 		Group g = (Group)this.SendRMReplyCache.get(index);
		g.AL.add(rm);
	} else {			Group g = new Group();
		g.AL.add(rm);
		this.SendRMReplyCache.add(g);
	}
	rm.setState(rm.UndeliveredFault);
	}
	
	public void SoapINRmRequestGroupExistedUpdateGroupTime(ReliableMessage rm, Group g) {
	if ( g.getGroupExpiryTime() == null ) {			int duration = WSRMUtil.stringParseInteger(rm.getIMessageContext().getRequestServices().
				selector("Envelope\\Header\\Request\\MessageId\\" +
						"SequenceNum", "groupMaxIdleDuration"));
		if ( duration != g.getGroupMaxIdleDuration() ) {				g.setGroupMaxIdleDuration(duration);
		}							
	} else {			String sGroupExpiryTime = rm.getIMessageContext().getRequestServices().
				selector("Envelope\\Header\\Request\\MessageId" +
						"\\SequenceNum", "groupExpiryTime");
		Date rmDate = WSRMUtil.stringParseDate(sGroupExpiryTime);
		if ( rmDate.getTime() != g.getGroupExpiryTime().getTime() ) {
						g.updateGroupExpiryTime(rmDate);
		}
	}
	g.setStartTime(System.currentTimeMillis());
	}
	public void SoapINRmRequestNewGroup(ReliableMessage rm) {
	Group g = new Group();
	g.setAll(rm);
	g.addMessage(rm);
	this.ReceiveRMCache.add(g);
	g.setStartTime(System.currentTimeMillis());
	}
	
	
	public ArrayList Deliver() {
	
	ArrayList result = new ArrayList();
	for ( int i = 0; i < this.ReceiveRMCache.size(); i ++ ) {
		Group r = (Group)this.ReceiveRMCache.get(i);
		String groupId = r.getGroupId();
		if ( ( r.getState() == r.Running ) && ( r.getSize() > 0 ) ) {
			
			if ( r.getOrderedDelivery() ) {					deliveryByOrder(result, r, groupId);
			} else {					deliveryByOthers(result, r, groupId);
			}
						r.stateUpdate(r.ReceivingRMP);
		}
	}
	return result;
	}
	public void deliveryByOthers(ArrayList result, Group r, String groupId) {
	ReliableMessage rm = null;
	for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
		rm = r.getMessage(circle);
		if ( rm.getState() == rm.UndeliveredWait && !WSRMUtil.testExpiry( rm.getExpiryTime() ) ) {
						deliveryByReplyPatternValue(groupId, rm);
			try {
				 
				ReliableMessage cloneRM = (ReliableMessage) rm.clone();
				result.add(cloneRM);
				cloneRM.setState(rm.DeliveredRight);
				rm.setState(rm.DeliveredRight);
			} catch (CloneNotSupportedException e) {
				e.printStackTrace();
			}
		}
	}
	}
	public void deliveryByOrder(ArrayList result, Group r, String groupId){
	ReliableMessage rm = null;
		r.sort();
	for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
		rm = r.getMessage(circle);
		if ( rm.getNumber() == (long)circle ) {				if ( rm.getState() == rm.UndeliveredWait && !WSRMUtil.testExpiry( rm.getExpiryTime() ) ) {
								deliveryByReplyPatternValue(groupId, rm);
				try {
					 
					ReliableMessage cloneRM = (ReliableMessage) rm.clone();
					result.add(cloneRM);
					cloneRM.setState(rm.DeliveredRight);
					rm.setState(rm.DeliveredRight);
				} catch (CloneNotSupportedException e) {
					e.printStackTrace();
				}
			} else if ( rm.getState() == rm.DeliveredRight ) {				} else {					System.out.println("P2PRMP.deliveryByOrder(): Previous RM not deliver after RM can not deliver");
				break;
			}
		} else { 			System.out.println("P2PRMP.deliveryByOrder(): Previous RM not received after RM can not deliver");
			break;
		}
	}
	}
	public void deliveryByReplyPatternValue(String groupId, ReliableMessage rm) {
		String replyPattern = rm.getReplyPatternValue();
	if ( "Response".equals(replyPattern) ) {				} else if ( "Callback".equals(replyPattern) ) {
		
		ReliableMessage rmCallback = null;
		try {
			rmCallback = (ReliableMessage)rm.clone();
		} catch (CloneNotSupportedException e) {
						System.out.println("P2PRMP.deliveryByReplyPatternValue(): Clone Error");
		}
				rmCallback = rmCallback.adjustRM(rmCallback);	
		int index = GroupHasExisted(this.SendRMReplyCache, groupId);
		if ( -1 != index ) { 			Group g = (Group)this.SendRMReplyCache.get(index);
			g.AL.add(rmCallback);
		} else {				Group g = new Group();
			g.AL.add(rmCallback);
			this.SendRMReplyCache.add(g);
		}
	} else { 		
	}
	}
	public void SoapINRmResponse(ReliableMessage rm) {		if ( !IfCacheFull(this.ReceiveRMReplyCache) ) { 		String groupId = rm.getGroupId();
		int index = GroupHasExisted(this.ReceiveRMReplyCache, groupId);
		if ( -1 != index ) { 			SoapINRmResponseGroupExisted(rm, index);
		} else {				SoapINRmResponseNewGroup(rm);
		}
	} else {											System.out.println("P2PRMP.rmpProcessSoapRequestRmResponse(): Do nothing and just throw away the RM ");
	}
	}
	public void SoapINRmResponseGroupExisted(ReliableMessage rm, int index) {
	Group g = (Group)this.ReceiveRMReplyCache.get(index);
	g.AL.add(rm);
	}
	public void SoapINRmResponseNewGroup(ReliableMessage rm) {
	Group g = new Group();
	g.setAll(rm);
		g.AL.add(rm);
		rm.setState(rm.DeliveredRight);
		this.ReceiveRMReplyCache.add(g);
	g.setStartTime(System.currentTimeMillis());
	}
	
	public ArrayList SoapINRmRequestResponse(ReliableMessage rm, ArrayList result) {
				
	if ( !IfCacheFull(this.ReceiveRMReplyCache) ) { 	} else { 	}
	return result;
	}
	
	public ArrayList SoapINRmPollRequest(ReliableMessage rm) { 	ArrayList result = new ArrayList();
	if ( !IfCacheFull(this.ReceiveRMCache) ) { 		
		result.add(rm);
	} else { 						FaultCacheFull(rm, false);
	}	
	return result;
	}
	
	public ArrayList Notify() {
			ArrayList result = new ArrayList();
	ReliableMessage rm = null;
	for ( int i = 0; i < this.ReceiveRMReplyCache.size(); i ++ ) {
		Group r = (Group)this.ReceiveRMReplyCache.get(i);	
				int index = GroupHasExisted(this.SendRMCache, r.getGroupId());
		if ( -1 != index ) { 			Notify_RmInSendCache(result, i, r);
		} else { 			Notify_RmNotInSendCache();
		}
				for (int j=0; j<r.AL.size(); j++){
			if ( -1 != index ) {
				
			} else {
					rm = (ReliableMessage)r.AL.get(j);
					result.add(rm);
			}
		}
	}
	return result;
	}
	
	public void Notify_RmInSendCache(ArrayList result, int i, Group r) {
	ReliableMessage rm = null;
	Group g = (Group)this.SendRMCache.get(i);
	for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
		rm = (ReliableMessage)r.getMessage(circle);
				rm.setNumber(0L);
		long number = rm.getNumber();
		if ( number >= g.AL.size() ) {
						System.out.println("P2PRMP.Notify(): " +
					"Error -- Returned RM-Reply out of the sending group range");
		} else { 			Metaset Body = (Metaset)( (Metaset)rm.getIMessageContext().
					getRequestServices().filter(".\\Body") ).getChilds().get(0);
			if (Body != null) {
				Metaset Fault = (Metaset)( (Metaset)rm.getIMessageContext().
						getRequestServices().filter(".\\Body\\Fault") );
				if (Fault != null) {
					rm.setState(rm.SentAndNotifyFault);
				} else {
					rm.setState(rm.SentAndNotifyAck);
				}
			}
			if (rm.getState() == rm.SentAndNotifyAck) { 				( (ReliableMessage) g.getMessage( (int)number ) ).setState( rm.SentAndNotifyAck );
				if ( Body != null ) { 					Metaset Header = (Metaset)( (Metaset)rm.getIMessageContext().
							getRequestServices().filter(".\\Header") ).getChilds().get(0);
										Metaset Response = (Metaset)( (Metaset)rm.getIMessageContext().
							getRequestServices().filter(".\\Header\\Response") ).getChilds().get(0);
					if ( Response != null ) {
						Header.remove(Response);
					}
					result.add(rm);
				} else { 				}
			} else if (rm.getState() == rm.SentAndNotifyFault) { 				reSendorErrorDeal(rm, g, number);
			} else { 				System.out.println("P2PRMP.Notify(): Impossible ways to run");
			} 
		}
	}
	}
	
	public void reSendorErrorDeal(ReliableMessage rm, Group s, long number) {
	String state = rm.getMessageFormatState();
	if ( state.startsWith("MessageProcessingFailure") ) {
				if ( rm.getGuaranteedDelivery() || rm.getOrderedDelivery() ) {
			( (ReliableMessage) s.getMessage( (int)number ) ).setState( rm.NotSent );
		} else {
			( (ReliableMessage) s.getMessage( (int)number ) ).setState(rm.SentAndNotifyFault);
		}
	} else {
				( (ReliableMessage) s.getMessage( (int)number ) ).setState( rm.SentAndNotifyFault );
	}
	}
	
	public void reSend(String groupId) {
	int index = GroupHasExisted(this.SendRMCache, groupId);
	Group g = (Group) this.SendRMCache.get(index);
	if ( g.AL.size() <= 0 ) {
		return;
	}
	IObjectPool transportOutputPool = 
		Application.getRuntime().
		getObjectPool("transport",IObjectPool.OUT_MODE);
	synchronized (transportOutputPool) {
		while (transportOutputPool.full()) {
			try {
				transportOutputPool.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		ReliableMessage rm = null;
		for ( int i = 0; i < g.AL.size() ; i ++ ) {
			rm = (ReliableMessage)g.AL.get(i);
									if (rm.SentAndNotNotify == rm.getState()) {
				ITransportContext.ResponseTransportContext rtc = 
					rm.getIMessageContext().getResponseTransportContext();
				rtc.setContent(rm.getIMessageContext().getResponseServices());
				transportOutputPool.put(rtc);
				transportOutputPool.notifyAll();
			}
		}
	}
	}
	
	public void Notify_RmNotInSendCache() {
			System.out.println("P2PRMP.Notify(): Error -- " +
			"Receiving Side returned Reliable Group " +
			"is not sent by Sending Site ");
	}
		
	
	
	private static Random r = new Random(129304901243092394L);
	
	public synchronized ArrayList SoapOUT(IMessageContext obj){
	ArrayList result = new ArrayList();
	ReliableMessage rm = new ReliableMessage();
	rm.setIMessageContext(obj);
	
		
	
	
	if ( rm.getIMessageContext().getRequestServices() == null ) {
				rm.setType(rm.InitType);
	} else { 				rm.testRMType("Right");
	}
	
	try {
		rm.testMessageFormatFault();
	} catch (TestMessageFormatException tmfe) {
				System.out.println("P2PRMP.rmpProcessSoapResponse(): test Message Format Exception");
	}
		int type = rm.getType();
	if ( type == rm.InitType ) {			String s = "Not a WS-R 1.1 supported Reliable Message";
		if ( s.equals( rm.getMessageFormatState() ) ) {	
									result.add(rm);
		} else {	
												ClearSendRMCache();
			SoapOUTRmInit(rm);
			result = Submit();
		}
	} else if ( type == rm.RequestType ) {					ClearSendRMReplyCache();
		SoapOUTRmRequest(rm);
		result = Respond();
	} else if ( type == rm.PollRequestType ) {			result = SoapOUTRmPollReqt(rm);
	} else if ( type == rm.RequestResponseType ) {			System.out.println("P2PRMP.rmpProcessSoapResponse(): " +
				"Impossible way to receive 'Request-Response' Rm");
	} else {			System.out.println("P2PRMP.rmpProcessSoapResponse(): " +
				"Impossible way to receive 'Response' Rm");
	}
	return result;
	}
	
	private void SoapIN_ResponseWSA(ReliableMessage rm) {
								Metaset envelope = (Metaset) rm.getIMessageContext().getResponseServices();
		Metaset header = (Metaset)(envelope.filter(".\\Header"));
		if (header == null) {
			header = new Metaset("SOAP-ENV", "Header");
			header.add(new Attribute(new QName("xmlns", "wsa"), 
				"http://www.w3.org/2005/03/addressing"));
		}		
		Metaset newID = new Metaset("wsa", "MessageID");
				String id = "" + System.currentTimeMillis() + r.nextLong();
		newID.add(new Attribute(new QName("SOAP-ENV", "mustUnderstand"), "0"));
		newID.setValue(id);
				Metaset oldID = null;
		if (header != null) {
			oldID = (Metaset) (envelope.filter(".\\Header\\MessageID"));
		}
		Metaset relaID = new Metaset("wsa", "RelatesTo");
		if (oldID != null) {
			String value = ((Metaset)oldID.getChilds().get(0)).getValue();
			relaID.setValue(value);
		}
				if (oldID != null) {
			((Metaset)header.getChilds().get(0)).
				remove((Metaset)oldID.getChilds().get(0));
		}
		Metaset soapto = (Metaset)(envelope.filter(".\\Header\\To"));
		String toAddress = null;
		if (soapto != null) {
			toAddress = ((Metaset)soapto.getChilds().get(0)).getValue();
			((Metaset)header.getChilds().get(0)).remove((Metaset)soapto.getChilds().get(0));
		}
		Metaset soapfrom = (Metaset)(envelope.filter(".\\Header\\From"));
		String fromAddress = null;
		if (soapfrom != null) {
			fromAddress = (((Metaset)((Metaset)soapfrom.getChilds().
					get(0)).filter(".\\Address").
					getChilds().get(0)).getValue());
			((Metaset)header.getChilds().get(0)).remove((Metaset)soapfrom.getChilds().get(0));
		}
				((Metaset)header.getChilds().get(0)).add(newID);
		if (oldID != null) {
			((Metaset)header.getChilds().get(0)).add(relaID);
		}
		if (soapfrom != null) {
			((Metaset)((Metaset)soapfrom.getChilds().
				get(0)).filter(".\\Address").getChilds().get(0))
				.setValue(toAddress);
			((Metaset)header.getChilds().get(0)).add((Metaset)soapfrom.getChilds().get(0));
		}
		if (soapto != null) {
			((Metaset)soapto.getChilds().get(0)).setValue(fromAddress);
			((Metaset)header.getChilds().get(0)).add((Metaset)soapto.getChilds().get(0));
		}
	}
	
	public void SoapOUTRmInit(ReliableMessage rm) { 	if ( !IfCacheFull(this.SendRMCache) ) { 				Metaset Request = new Metaset("wsrm", "Request");
		Request.add(new Attribute(new QName("xmlns", "wsrm"), 
				"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
		Request.add(new Attribute(new QName("xmlns", "soap12"), 
				"http://www.w3.org/2003/05/soap-envelope"));
		Request.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
		Metaset MessageId = new Metaset("wsrm", "MessageId");
				String groupId = "" + System.currentTimeMillis() + random.nextLong();
		MessageId.add(new Attribute(new QName("xsd", "groupId"), groupId));
		Request.add(MessageId);
		Metaset ExpiryTime = new Metaset("wsrm", "ExpiryTime");
		String expTime = "2008-08-08T08:08:00-22:00";
		ExpiryTime.setValue(expTime);
		Request.add(ExpiryTime);
		Metaset ReplyPattern = new Metaset("wsrm", "ReplyPattern");
		Metaset Value = new Metaset("Value");
		String ReplyPatternValue = "Response";
		Value.setValue(ReplyPatternValue);
		ReplyPattern.add(Value);
		Request.add(ReplyPattern);
		Metaset AckRequested = new Metaset("wsrm", "AckRequested");
		Request.add(AckRequested);
		Metaset DuplicateElimination = new Metaset("wsrm", "DuplicateElimination");
		Request.add(DuplicateElimination);
		Metaset Envelope = rm.getIMessageContext().getResponseServices();
		if ( null == Envelope.filter(".\\Header") ) { 			Metaset Header = new Metaset("soapenv", "Header");
			Metaset Body = new Metaset("Body");
			Body = (Metaset)Envelope.getChilds().get(0);
			Envelope.remove( (Metaset)Envelope.getChilds().get(0) );
			Header.add(Request);
			Envelope.add("Envelope\\", Header);
			Envelope.add(Body);
		} else { 			Metaset Header = (Metaset)( Envelope.filter(".\\Header") ).getChilds().get(0);
			Metaset RequestSet = null;
			if ( rm.getIMessageContext().getResponseServices() != null ) {
				RequestSet = (Metaset)( (Metaset)rm.getIMessageContext().
						getResponseServices().filter(".\\Header\\Request") );
			}
			if (RequestSet == null) {
				Header.add(Request);
			}
		}
				rm.setType(rm.RequestType);
		rm.setSoapMEP(rm.SoapRequestResponse);			
		rm.setMessageFormatState("Right");
		rm.setGroupId(groupId);
		rm.setNumber(0L);
		rm.setExpiryTime( WSRMUtil.stringParseDate(expTime) );
		rm.setReplyPatternValue(ReplyPatternValue);
		rm.setGuaranteedDelivery(true);
		rm.setNoDuplicateDelivery(true);
		rm.setExactlOnceDelivery(false);
		rm.setOrderedDelivery(false);
		rm.setState(rm.NotSent);
				Group g = new Group();
		g.setAll(rm);
		g.AL.add(rm);
		this.SendRMCache.add(g);
		g.setStartTime(System.currentTimeMillis());
				if (WSRMUtil.SupportTimerTask) {
			try {
						    			    	g.myReSendTimer = new Timer();
		    	g.gReSendTask = new GroupReSendTask(rm.getGroupId());
		    					g.myReSendTimer.schedule(g.gReSendTask, 20000, 20000);
			} catch (IllegalArgumentException arg) {
				arg.printStackTrace();
			} catch (IllegalStateException state) {
				state.printStackTrace();
			}
		}
	} else { 						FaultCacheFull(rm, true);
	}
	}
	
	public void SoapOUTRmRequest(ReliableMessage rm) {
		if ( !IfCacheFull(this.SendRMReplyCache) ) { 		String groupId = rm.getGroupId();
		int index = GroupHasExisted(this.SendRMReplyCache, groupId);
		if ( -1 != index ) { 			SoapOUTRmRequestGroupExisted(rm, index);
		} else {				SoapOUTRmRequestNewGroup(rm);
		}
	} else {											System.out.println("P2PRMP.rmpProcessSoapResponseRmRequest(): " +
				"Do nothing and just throw away the RM ");
	}
	}
	
	public void SoapOUTRmRequestGroupExisted(ReliableMessage rm, int index) {
	Group g = (Group)this.SendRMReplyCache.get(index);
	SoapOUTRmRequestByReplyPatternValue(rm, g);
	}
	
	public void SoapOUTRmRequestNewGroup(ReliableMessage rm) {
	Group g = new Group();
	SoapOUTRmRequestByReplyPatternValue(rm, g);
	this.SendRMReplyCache.add(g);
	}
	public void SoapOUTRmRequestByReplyPatternValue(ReliableMessage rm, Group g) {
	if ( "Response".equals( rm.getReplyPatternValue() ) ) {
		
		ReliableMessage rmResponse = rm.adjustRM(rm);
		rmResponse.setState(rm.UndeliveredWait);
		g.AL.add(rmResponse);
	} else if ( "Callback".equals( rm.getReplyPatternValue() ) ) {
		
				String url = null;
		Metaset BareURI = rm.getIMessageContext().getRequestServices().filter("Envelope\\Header" +
									"\\Request\\ReplyPattern\\ReplyTo\\BareURI");
		if ( BareURI != null ) {				String URI = ( (Metaset) BareURI.getChilds().get(0) ).getValue();
			url = URI;
		} else {				String rs = rm.getIMessageContext().getRequestServices().selector("Envelope\\Header" +
					"\\Request\\ReplyPattern\\ReplyTo", "reference-scheme");
			url = rs;
		}
		RequestTransportContext httpContext = (RequestTransportContext) new HTTPURLResponseTransportContext(url);
		rm.getIMessageContext().setResponseTransportContext((ResponseTransportContext) httpContext);
		Metaset Header = (Metaset)( (Metaset)rm.getIMessageContext().getResponseServices().
											filter(".\\Header") ).getChilds().get(0);			
		Header.remove( (Metaset)Header.getChilds().get(0) );
		rm.setState(rm.UndeliveredWait);
		g.AL.add(rm);
	} else {			rm.setState(rm.UndeliveredWait);
		g.AL.add(rm);
	}
	}
	
	public ArrayList SoapOUTRmPollReqt(ReliableMessage rm) {
		ArrayList result = new ArrayList();
	Metaset replyTo = rm.getIMessageContext().getResponseServices().filter("Envelope\\Header" +
								"\\PollRequest\\ReplyTo");
	if ( replyTo!= null ) { 				String url = null;
		Metaset BareURI = rm.getIMessageContext().getResponseServices().filter("Envelope\\Header" +
									"\\PollRequest\\ReplyTo\\BareURI");
		if ( BareURI != null ) {				String URI = ( (Metaset) BareURI.getChilds().get(0) ).getValue();
			url = URI;
		}
		else {				String rs = rm.getIMessageContext().getResponseServices().selector("Envelope\\Header" +
							"\\PollRequest\\ReplyTo", "reference-scheme");
			url = rs;
		}
		RequestTransportContext httpContext = (RequestTransportContext) new HTTPURLResponseTransportContext(url);
		rm.getIMessageContext().setResponseTransportContext((ResponseTransportContext) httpContext);
	} else {		}
	SoapOUTRmPollReqtSetRepo(rm);
	result.add(rm);
	return result;
	}
	public void SoapOUTRmPollReqtSetRepo(ReliableMessage rm) {
	Metaset Response = new Metaset("Response");
	Metaset RefToMessageIds = SoapOUTRmPollReqtSetRepoSetAttr(rm, Response);
	rm = SoapOUTRmPollReqtSetRepoSetChilds(rm, Response, RefToMessageIds);
	Metaset Header = (Metaset)( (Metaset)rm.getIMessageContext().getResponseServices().
			filter(".\\Header") ).getChilds().get(0);
	Header.remove( (Metaset)Header.getChilds().get(0) );
	Header.add(Response);
	}
	public Metaset SoapOUTRmPollReqtSetRepoSetAttr
						(ReliableMessage rm, Metaset Response) {
	Response.add(new Attribute(new QName("xmlns", "wsrm"), 
									"http://docs.oasis-open.org/wsrm/2004/06/ws-reliability-1.1.xsd"));
	Response.add(new Attribute(new QName("xmlns", "soap12"), "http://www.w3.org/2003/05/soap-envelope"));
	Response.add(new Attribute(new QName("soap12", "mustUnderstand"), "1"));
	Metaset RefToMessageIds = rm.getIMessageContext().getResponseServices().filter("Envelope\\Header" +
												"\\PollRequest\\RefToMessageIds");
	return RefToMessageIds;
	}
	public ReliableMessage SoapOUTRmPollReqtSetRepoSetChilds
							(ReliableMessage rm, Metaset Response, Metaset RefToMessageIds) {
	ReliableMessage tempRM = null;
	for ( int i = 0 ; i < RefToMessageIds.getChilds().size() ; i ++ ) {
		String groupId = ( (Attribute) ( (Metaset) RefToMessageIds.getChilds().get(i) ).
								getAttributes().get(0) ).getValue();
		int index = GroupHasExisted(this.SendRMReplyCache, groupId);
		if ( -1 != index ) { 			Group g = (Group)this.SendRMReplyCache.get(index);
			Metaset SequenceNumRange = rm.getIMessageContext().getResponseServices().filter("Envelope" +
					"\\Header\\PollRequest\\RefToMessageIds\\SequenceNumRange");
			if ( SequenceNumRange != null ) {					rm = SoapOUTRmPollReqtSetRepoSeqReply
						(rm, Response, tempRM, groupId, g, SequenceNumRange);
			} else {					tempRM = SoapOUTRmPollReqtSetRepoNoSeqReply(rm, Response, tempRM, g);
			}
		} else {				Metaset NonSequenceReply = new Metaset("NonSequenceReply");
			NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
			NonSequenceReply.add(new Attribute(new QName("xsd", "fault"), 
								"wsrm: PermanentProcessingFailure -- Group is not exist"));
			Response.add(NonSequenceReply);
		}
	}
	return rm;
	}
	public ReliableMessage SoapOUTRmPollReqtSetRepoSeqReply
							(ReliableMessage rm, Metaset Response, ReliableMessage tempRM, String groupId, 
									Group g, Metaset SequenceNumRange) {
	Metaset tempSS;
	Metaset SequenceReplies = new Metaset("SequenceReplies");
	SequenceReplies.add(new Attribute(new QName("xsd", "groupId"), groupId));
	for ( int circle = 0 ; circle < SequenceNumRange.getChilds().size() ; circle ++ ) {
		tempSS = (Metaset)SequenceNumRange.getChilds().get(circle);
		String from = ( (Attribute)tempSS.getAttributes().get(0) ).getValue(); 
		String to   = ( (Attribute)tempSS.getAttributes().get(1) ).getValue() ;
		long iFrom = WSRMUtil.stringParseLong(from);
		long iTo   = WSRMUtil.stringParseLong(to);
		if ( (long)g.AL.size() > iTo && iTo >= iFrom && iFrom >= 0L ) {
			rm = SoapOUTRmPollReqtSetRepoValid
				(rm, tempRM, g, SequenceReplies, iFrom, iTo);
		} else {				SoapOUTRmPollReqtSetRepoInvalid(SequenceReplies, iFrom, iTo);
		}
	}
	Response.add(SequenceReplies);
	return rm;
	}
	public ReliableMessage SoapOUTRmPollReqtSetRepoNoSeqReply
							(ReliableMessage rm, Metaset Response, ReliableMessage tempRM, Group g) {
	Metaset NonSequenceReply = new Metaset("NonSequenceReply");
	NonSequenceReply.add(new Attribute(new QName("xsd", "groupId"), rm.getGroupId()));
	if ( g.AL.size() > 1 ) {
		NonSequenceReply.add(new Attribute(new QName("xsd", "fault"), 
				"wsrm: InvalidMessageId -- SequenceNumRange should occur"));
	} else {
		tempRM = (ReliableMessage)g.AL.get(0);
		if ( rm.UndeliveredFault != tempRM.getState() ) {				tempRM.setState(rm.DeliveredRight);
		} else {				NonSequenceReply.add(new Attribute(new QName("xsd", "fault"), 
					"wsrm: PermanentProcessingFailure -- Message Delivery Failures"));
		}
	}
	Response.add(NonSequenceReply);
	return tempRM;
	}
	public void SoapOUTRmPollReqtSetRepoInvalid
				(Metaset SequenceReplies, long iFrom, long iTo) {
	Metaset ReplyRange  = new Metaset("ReplyRange");
	ReplyRange.add(new Attribute(new QName("xsd", "from"), Long.toString(iFrom)));
	ReplyRange.add(new Attribute(new QName("xsd", "to"), Long.toString(iTo)));
	ReplyRange.add(new Attribute(new QName("xsd", "fault"), 
						"wsrm: InvalidMessageId -- illegal 'from' / 'to'"));
	SequenceReplies.add(ReplyRange);
	}
	public ReliableMessage SoapOUTRmPollReqtSetRepoValid
							(ReliableMessage rm, ReliableMessage tempRM, 
							Group g, Metaset SequenceReplies, 
							long iFrom, long iTo) {
	long last = iFrom;
	for ( long k = iFrom ; k <= iTo ; k ++ ) {
		rm = (ReliableMessage)g.AL.get((int) k);
		if ( rm.UndeliveredFault != tempRM.getState() ) {							tempRM.setState(rm.DeliveredRight);
		} else {				if ( last == iFrom ) {					Metaset ReplyRange  = new Metaset("ReplyRange");
				ReplyRange.add(new Attribute(new QName("xsd", "from"), Long.toString(iFrom)));
				ReplyRange.add(new Attribute(new QName("xsd", "to"), Long.toString(iFrom)));
				ReplyRange.add(new Attribute(new QName("xsd", "fault"), 
							"wsrm: PermanentProcessingFailure -- Message Delivery Failures"));
				SequenceReplies.add(ReplyRange);
				
				last = iFrom + 1;
			} else { 				Metaset ReplyRange1  = new Metaset("ReplyRange");
				ReplyRange1.add(new Attribute(new QName("xsd", "from"), Long.toString(last)));
				ReplyRange1.add(new Attribute(new QName("xsd", "to"), Long.toString(k-1)));
				SequenceReplies.add(ReplyRange1);
				
				Metaset ReplyRange2  = new Metaset("ReplyRange");
				ReplyRange2.add(new Attribute(new QName("xsd", "from"), Long.toString(k)));
				ReplyRange2.add(new Attribute(new QName("xsd", "to"), Long.toString(k)));
				ReplyRange2.add(new Attribute(new QName("xsd", "fault"), 
							"wsrm: PermanentProcessingFailure -- Message Delivery Failures"));
				SequenceReplies.add(ReplyRange2);
				last = k + 1;
			}
		}
	}
	if ( last < iTo ) {
		Metaset ReplyRange  = new Metaset("ReplyRange");
		ReplyRange.add(new Attribute(new QName("xsd", "from"), Long.toString(last)));
		ReplyRange.add(new Attribute(new QName("xsd", "to"), Long.toString(iTo)));
		SequenceReplies.add(ReplyRange);
	}
	return rm;
	}
	
	
	
	public ArrayList Submit() {
	
	ArrayList result = new ArrayList();
	for ( int i = 0; i < this.SendRMCache.size(); i ++ ) {
		Group r = (Group)this.SendRMCache.get(i);
		String groupId = r.getGroupId();
		if ( ( r.getState() == r.Running ) && ( r.getSize() > 0 ) ) {
			
			if ( r.getOrderedDelivery() ) {					submityByOrder(result, r, groupId);
			} else {					submitByOthers(result, r, groupId);
			}
			r.stateUpdate(r.SendingRMP);
		}
	}
	return result;
	}
	public void submitByOthers(ArrayList result, Group r, String groupId) {
	ReliableMessage rm = null;
	for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
		rm = r.getMessage(circle);
		if ( rm.getState() == rm.NotSent && !WSRMUtil.testExpiry( rm.getExpiryTime() ) ) {
			try {
								ReliableMessage cloneRM = (ReliableMessage) rm.clone();
				result.add(cloneRM);
				rm.setState(rm.SentAndNotNotify);
				cloneRM.setState(cloneRM.SentAndNotNotify);
			} catch (CloneNotSupportedException e) {
				e.printStackTrace();
			}
		}
	}
	}
	public void submityByOrder(ArrayList result, Group r, String groupId) {
	ReliableMessage rm = null;
		r.sort();
	for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
		rm = r.getMessage(circle);
		if ( rm.getNumber() == (long)circle ) {				if ( rm.getState() == rm.NotSent && !WSRMUtil.testExpiry( rm.getExpiryTime() ) ) {
				try {
										ReliableMessage cloneRM = (ReliableMessage) rm.clone();
					result.add(cloneRM);
					rm.setState(rm.SentAndNotNotify);
					cloneRM.setState(cloneRM.SentAndNotNotify);
				} catch (CloneNotSupportedException e) {
					e.printStackTrace();
				}
			} else {				}
		} else {				break;
		}
	}
	}
	
	
	
	public ArrayList Respond() {
		ClearSendRMReplyCache();
	ArrayList result = new ArrayList();
	ReliableMessage rm = null;
	for ( int i = 0; i < this.SendRMReplyCache.size(); i ++ ) {
		Group r = (Group)this.SendRMReplyCache.get(i);
		for ( int circle = 0 ; circle < r.AL.size() ; circle ++ ) {
			
			rm = r.getMessage(circle);
			if ( "Poll".equals( rm.getReplyPatternValue() ) ) {	
				Respond_Poll(result, rm);
			} else {
				Respond_notPoll(result, rm);
			}
		}
	}
	return result;
	}
	public void Respond_Poll(ArrayList result, ReliableMessage rm) {
		ReliableMessage poll = null;
	try {
		poll = (ReliableMessage)rm.clone();
	} catch (CloneNotSupportedException e) {
				System.out.println("P2PRMP.Respond(): Clone error");
	}
	poll = poll.adjustRM(poll);
	
	if ( rm.getState() != rm.UndeliveredFault ) {
		rm.setState(rm.UndeliveredWait);
		poll.setState(poll.UndeliveredWait);
	}
	result.add(poll);
	}
	public void Respond_notPoll(ArrayList result, ReliableMessage rm) {
	
		if ( rm.getState() != rm.UndeliveredFault ) {
		rm.setState(rm.DeliveredRight);
	}
	result.add(rm);
	}
	
	
}
