package org.act.services.protocol.wsdl;
import java.util.Iterator;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.Handler;
import org.act.services.IMessageContext;
import org.act.services.ServicesObject;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.ServicesProtocol;
import org.act.services.runtime.Application;
import org.act.services.thread.ObjectProducerThreadPoolRunnable;
import org.act.services.wsdl.model.IServicesContextPool;
import org.act.services.wsdl.model.NoSuchServicesMethodException;
import org.act.services.wsdl.model.ServicesContext;
import org.act.services.wsdl.model.ServicesMethod;

public class WSDL12ServicesProtocol extends ServicesProtocol {
	public WSDL12ServicesProtocol() {
		super();
	}
	public Object adapt(Object obj) {
		if (obj instanceof IMessageContext) {
			return new WSDLRequestProcessor((IMessageContext) obj);
		}
		else if (obj instanceof ServicesObject) {
			return new WSDLResponseProcessor((ServicesObject) obj);
		}
		return null;
	}
	public void config(Metaset config) throws ConfigException {
	}
	public void start() {
	}
	public void stop() {
	}
}

class WSDLRequestProcessor implements ObjectProducerThreadPoolRunnable {
	
	private IMessageContext msgContext;
	private IObjectPool servicesObjectInputPool;
	public WSDLRequestProcessor(
			IMessageContext msgContext) {
		this.msgContext = msgContext;
	}
	private void doHandler(ServicesObject object) {
				for (Iterator iter =
			object
				.getServiceContext()
				.getDeployContext()
				.getHandlers()
				.iterator();
			iter.hasNext();
			) {
			Handler handler = (Handler) iter.next();
			try {
				handler.process(object.getMessageContext());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	public void setReceiver(IObjectPool receiver) {
		this.servicesObjectInputPool = receiver;	
	}
	public Object[] getInitData() {
		return null;
	}
	public void runIt(Object[] thData) {
		ServicesContext context =
			IServicesContextPool.INSTANCE.getService(msgContext.getServicesName());
		if (context==null) {
					}
				ServicesObject object = null;
		try {
			ServicesMethod method = context.getMethod(msgContext.getRequestServices());
			if (Application.isDebug()) {
				System.out.println("Service Layer(Input):");
				System.out.println("Web Service Name:"+context.getWebServiceName());
				System.out.println("Web Service Method:"+method.toString());
			}
			object = new ServicesObject(context, msgContext, method);
		} catch (NoSuchServicesMethodException e1) {
			e1.printStackTrace();
		}
		doHandler(object);
		synchronized (servicesObjectInputPool) {
			while (servicesObjectInputPool.full() ) {
				try {
					servicesObjectInputPool.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			servicesObjectInputPool.put(object);
			servicesObjectInputPool.notifyAll();
		}
	}
}

class WSDLResponseProcessor implements ObjectProducerThreadPoolRunnable {
	private ServicesObject so;
	private IObjectPool messageOutputPool;
	
	
	public WSDLResponseProcessor(ServicesObject so) {
		this.so = so;
	}
	private void doPostHandler(ServicesObject object) {
				for (Iterator iter =
			object
				.getServiceContext()
				.getDeployContext()
				.getHandlers()
				.iterator();
			iter.hasNext();
			) {
			Handler handler = (Handler) iter.next();
			try {
				handler.postProcess(object.getMessageContext());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	public void setReceiver(IObjectPool receiver) {
		this.messageOutputPool = receiver;		
	}
	public Object[] getInitData() {
		return null;
	}
	public void runIt(Object[] thData) {
		
		doPostHandler(so);
		synchronized (messageOutputPool) {
			while (messageOutputPool.full()) {
								try {
					messageOutputPool.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			messageOutputPool.put(so.getMessageContext());
			messageOutputPool.notifyAll();
		}
	}
}
