package org.act.ws.provider;
import org.act.services.IMessageContext;
import org.act.services.ServicesObject;
import org.act.services.connector.AObjectPoolConnector;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.ProviderProtocol;
import org.act.services.runtime.IRuntime;
import org.act.services.runtime.lifecycle.LiftcycleException;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.ObjectProducerThreadPoolRunnable;
import org.act.services.thread.Terminatable;
import org.act.services.thread.ThreadPool;
public class SimpleConnector extends AObjectPoolConnector {
	private IObjectPool mci;
	private IObjectPool mco;
	private Terminatable provider;
	private ThreadPool threadPool;
	private Thread providerT;
	
	public SimpleConnector(ThreadPool threadPool, IRuntime runtime, IObjectPool i, IObjectPool o) {
		super(runtime);
		mci = i;
		mco = o;
		this.threadPool = threadPool;		provider = new Terminatable() {
			protected void process() throws ObjectOperationException {
								IMessageContext mc = null;
				synchronized (mci) {
					while (mci.empty()) {
						switch (getState()) {
							case RUNNING :
								try {
									mci.wait();
								} catch (InterruptedException e) {
									e.printStackTrace();
								}
								break;
							case STOPPING :
								return;
							default :
								throw new IllegalMonitorStateException();
						}
					}
					mc = (IMessageContext) mci.get();
					mci.notifyAll();
				}
				
				SimpleProvider sp = new SimpleProvider(mc, mco);
				SimpleConnector.this.threadPool.runIt(sp);
			}		
		};
	}
	public Object adapt(Object obj) {
		return null;
	}
	public void start() throws LiftcycleException {
				providerT = new Thread(provider);
		providerT.setName("Provider");
		providerT.start();
	}
	public void stop() throws LiftcycleException {
		provider.terminate();
		synchronized (mci) {
			mci.notifyAll();
		}
			}
	
}
