
package org.act.services.transaction.information;


import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.DriverManager;
import java.util.Vector;
import org.act.services.transaction.manager.SuperiorContext;
import org.act.services.transaction.manager.InferiorResource;
import org.act.services.transaction.util.Timer;
import org.act.services.transaction.util.LogCategory;
import org.apache.log4j.Category;
public class DBLog {
	
    private static Connection con = null;
    
    private static boolean isLog = TxSetting.getIsLogDB();
    
    private static Category log = LogCategory.getCategory("ݿ");
    
    public static Connection getConnection()
    {
        if (con == null)
        {
            try
            {
                                String driver = TxSetting.getDBDriverName();
                                Class.forName(driver);
                                String url = TxSetting.getDBAcessName();
                                con = DriverManager.getConnection(url);
                con.setAutoCommit(true);
            }
            catch (Exception e)
            {
                log.debug("ݿʧ:" + e.getMessage());
            }
        }
        return con;
    }
    
    public static void logSuperior(SuperiorContext sc)
    {
                if (!isLog)
        {
            return;
        }
        String txId = sc.getTransactionId();
        String txType = sc.isAtom() ? "atom" : "cohesion";
        String superId = sc.getSuperiorId();
        String superAddress = sc.getSuperiorAdress();
        String superiorType = sc.isTopTransaction() ? "top" : "child";
                String statusTime = Timer.getCNTime();
        String beginTime = statusTime;
        String status = sc.getTxStatus();
        try
        {                                        
                                                                  }
        catch (Exception e)
        {
            log.debug("superior¼ʱʧ:" + e.getMessage());
        }
    }
    
    public static void logSuperiorStatus(SuperiorContext sc)
    {
        logSuperiorStatus(sc, null);
    }
    
    public static void logSuperiorStatus(SuperiorContext sc, String comments)
    {
                if (!isLog)
        {
            return;
        }
        String status = sc.getTxStatus();
        String statusTime = Timer.getCNTime();
        String superiorId = sc.getSuperiorId();
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
                        String sql = "UPDATE superior SET status = '" + status
                         + "', statusTime = '" + statusTime
                         +
                         (comments == null ? "" : "', comments = '" + comments)
                         + "' WHERE superiorid = '" + superiorId + "'";
            stmt.executeUpdate(sql);
        }
        catch (Exception e)
        {
            log.debug("superiorsuperior״̬ļ¼ʱʧ:" + e.getMessage());
        }
    }
    
    public static void logInferior(InferiorResource ir)
    {
                if (!isLog)
        {
            return;
        }
        String txId = ir.getTransactionId();
        String inferiorId = ir.getInferiorId();
        String infeirorAddress = ir.getInfeirorAddress();
        String superId = ir.getSuperiorId();
                String statusTime = Timer.getCNTime();
        String enrollTime = statusTime;
        String status = ir.getSatus();
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String sql = "INSERT INTO inferior ("
                         +
                "transactionid, superiorid, inferiorid, inferioraddress,"
                + "enrolltime, statustime, status"
                + ") VALUES('" + txId + "','" + superId + "','" +
                inferiorId +
                "','"
                + infeirorAddress + "','" + enrollTime + "','" +
                statusTime
                + "','" + status + "')";
            stmt.executeUpdate(sql);
        }
        catch (Exception e)
        {
            log.debug("inferior¼ʱʧ:" + e.getMessage());
        }
    }
    
    public static void logInfeirorStatus(InferiorResource ir)
    {
        logInfeirorStatus(ir, null);
    }
    
    public static void logInfeirorStatus(InferiorResource ir, String comments)
    {
                if (!isLog)
        {
            return;
        }
        String status = ir.getSatus();
        String statusTime = Timer.getCNTime();
        String inferiorId = ir.getInferiorId();
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String sql = "UPDATE inferior SET status = '" + status
                         + "', statusTime = '" + statusTime
                         +
                         (comments == null ? "" : "', comments = '" + comments)
                         + "' WHERE inferiorid = '" + inferiorId + "'";
            stmt.executeUpdate(sql);
        }
        catch (Exception e)
        {
            log.debug("inferiorıinferior״̬ļ¼ʱʧ:" + e.getMessage());
        }
    }
    
    public static void logInferiorStatus(String infeirorId, String status)
    {
                if (!isLog)
        {
            return;
        }
        String statusTime = Timer.getCNTime();
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String sql = "UPDATE superior SET status = '" + status
                         + "', statusTime = '" + statusTime
                         + "' WHERE inferiorid = '" + infeirorId + "'";
            stmt.executeUpdate(sql);
        }
        catch (Exception e)
        {
            log.debug("inferiorıinferior״̬ļ¼ʱʧ:" + e.getMessage());
        }
    }
    
    public static Vector getAllSuperiors()
    {
        return internalGetSuperiors(null);
    }
    
    public static Vector getSuperiors(String txId)
    {
        return internalGetSuperiors(txId);
    }
    
    public static Vector getAllInferiors( )
    {
        return internalGetInferiors(null);
    }
    
    public static Vector getInferiors(String txId)
    {
        return internalGetInferiors(txId);
    }
    
    public static Vector getInferiorsOfSuperior(String superiorId)
    {
        Vector result = new Vector();
        String sql = null;
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String condition = null;
            if (superiorId != null)
            {
                condition = "where superiorid = " + "'" + superiorId + "'";
            }
                        sql = "SELECT * from inferior " + condition + " order by id desc";
                        ResultSet rs = stmt.executeQuery(sql);
            while (rs.next())
            {
                Vector record = new Vector();
                String id = rs.getString("id");
                String transactionId = rs.getString("transactionId");
                String superiorid = rs.getString("superiorid");
                String inferiorid = rs.getString("inferiorid");
                String inferioraddress = rs.getString("inferioraddress");
                String enrolltime = rs.getString("enrolltime");
                String statustime = rs.getString("statustime");
                String status = rs.getString("status");
                record.add(id);
                record.add(transactionId);
                record.add(superiorid);
                record.add(inferiorid);
                record.add(inferioraddress);
                record.add(enrolltime);
                record.add(statustime);
                record.add(status);
                result.add(record);
            }
            return result;
        }
        catch (Exception e)
        {
            log.debug("ѯϢʱʧ:" + e.getMessage() + " SQL䣺" + sql);
            return result;
        }
    }
    private static Vector internalGetSuperiors(String txId)
    {
        Vector result = new Vector();
        String sql = null;
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String condition = "";
            if (txId != null)
            {
                condition = "where transactionid = " + "'" + txId + "'";
            }
                        sql =  "SELECT * FROM superior " + condition +  " order by id desc";
            ResultSet rs = stmt.executeQuery(sql);
            while (rs.next())
            {
                Vector record = new Vector();
                String id = rs.getString("id");
                String transactionId = rs.getString("transactionId");
                String transactiontype = rs.getString("transactiontype");
                String superiortype = rs.getString("superiortype");
                String superiorid = rs.getString("superiorid");
                String superioraddress = rs.getString("superioraddress");
                String begintime = rs.getString("begintime");
                String statustime = rs.getString("statustime");
                String status = rs.getString("status");
                record.add(id);
                record.add(transactionId);
                record.add(transactiontype);
                record.add(superiortype);
                record.add(superiorid);
                record.add(superioraddress);
                record.add(begintime);
                record.add(statustime);
                record.add(status);
                result.add(record);
            }
            return result;
        }
        catch (Exception e)
        {
            log.debug("ѯЭϢʱʧ:" + e.getMessage() + "  SQL䣺" + sql);
            return result;
        }
    }
    private static Vector internalGetInferiors(String txId)
    {
        Vector result = new Vector();
        String sql = null;
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            String condition = null;
            if (txId != null)
            {
                condition = "where transactionid = " + "'" + txId + "'";
            }
                        sql = "SELECT * from inferior " + condition + " order by id desc";
            ResultSet rs = stmt.executeQuery(sql);
            while (rs.next())
            {
                Vector record = new Vector();
                String id = rs.getString("id");
                String transactionId = rs.getString("transactionId");
                String superiorid = rs.getString("superiorid");
                String inferiorid = rs.getString("inferiorid");
                String inferioraddress = rs.getString("inferioraddress");
                String enrolltime = rs.getString("enrolltime");
                String statustime = rs.getString("statustime");
                String status = rs.getString("status");
                record.add(id);
                record.add(transactionId);
                record.add(superiorid);
                record.add(inferiorid);
                record.add(inferioraddress);
                record.add(enrolltime);
                record.add(statustime);
                record.add(status);
                result.add(record);
            }
            return result;
        }
        catch (Exception e)
        {
            log.debug("ѯϢʱʧ:" + e.getMessage() + " SQL䣺" + sql);
            return result;
        }
    }
    
    public static int delSuperiors(Vector IDs)
    {
        int result = 0;
        try
        {
            con = getConnection();
            Statement stmt = con.createStatement();
            int count = IDs.size();
            if (count > 0)
            {
                String sql = "DELETE FROM superior where id in (";
                for (int i = 0; i < count; i++)
                {
                    sql = sql +  IDs.get(i) +  ",";
                }
                sql = sql.substring(0, sql.length()-1) + ")";
                result = stmt.executeUpdate(sql);
            }
        }
        catch (Exception e)
        {
            log.debug("ɾЭϢʱʧ:" + e.getMessage());
        }
        return result;
    }
       
       public static int delInferiors(Vector IDs)
       {
           int result = 0;
           try
           {
               con = getConnection();
               Statement stmt = con.createStatement();
               int count = IDs.size();
               if (count > 0)
               {
                   String sql = "DELETE FROM inferior where id in (";
                   for (int i = 0; i < count; i++)
                   {
                       sql = sql +  IDs.get(i) +  ",";
                   }
                   sql = sql.substring(0, sql.length()-1) + ")";
                   result = stmt.executeUpdate(sql);
               }
           }
           catch (Exception e)
           {
               log.debug("ɾϢʱʧ:" + e.getMessage());
           }
           return result;
       }
    
    public static void closeConnection()
    {
        if (con != null)
        {
            try
            {
                con.close();
            }
            catch (Exception e)
            {}
        }
    }
    public static void main(String[] args)
    {
        Vector v = new Vector();
        v.add("343");
        v.add("345");
        DBLog.getInferiorsOfSuperior("http://192.168.2.211:8080/TransactionManager#[2003/7/28 AM 6:47:54:300 8220]");
        DBLog.getAllInferiors();
    }
}
