
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class ApplicationMessage extends Message{
	 XElement xml_ = null;
	    String opName = null;
	    XElement param = null;
	    
	    public ApplicationMessage(String opName, XElement paramEle)
	    {
	        super("", Message.TYPE_UNKNOWN);
	        XElement appEle = new XElement(opName);
	        appEle.addElement(paramEle);
	        xml_ = appEle;
	    }
	    
	    public ApplicationMessage(String xml)
	    {
	        super("", Message.TYPE_UNKNOWN);
	        try
	        {
	            xml_ = MessageUtil.parseMessage(xml).toXml();
	            opName = xml_.getLocalName();
	            if (xml_.getNodes().size() > 0)
	            {
	                param = (XElement)xml_.getNodes().elementAt(0);
	            }
	        }
	        catch (Exception e)
	        {
	            xml_ = null;
	        }
	    }
	    
	    public ApplicationMessage(XElement el)
	    {
	        super(el, Message.TYPE_UNKNOWN);
	        xml_ = el;
	        opName = xml_.getLocalName();
	        if (xml_.getNodes().size() > 0)
	        {
	            param = (XElement)xml_.getNodes().elementAt(0);
	        }
	    }
	    
	    public String getOperationName()
	    {
	        return this.opName;
	    }
	    
	    public XElement getParamElement()
	    {
	        return this.param;
	    }
	    
	    public XElement toXml()
	    {
	        return xml_;
	    }
	    public static void main(String[] args)
	    {
	        String xml =
	            "<getMyName><person><name>yr</name><age>24</age></person></getMyName>";
	        ApplicationMessage applicationMessage1 = new ApplicationMessage(xml);
	        System.out.println(applicationMessage1.toString());
	        String op = applicationMessage1.getOperationName();
	        XElement ele = applicationMessage1.getParamElement();
	        System.err.println(op);
	        System.out.println(ele);
	    }
}
