
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Begin extends Message{
	 
    private boolean atom_ = true;
    
    public Begin()
    {
        super("btp:begin", Message.TYPE_BEGIN);
    }
    
    public Begin(XElement el)
    {
        super(el, Message.TYPE_BEGIN);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:begin/btp:transaction-type");
        if (obj != null)
        {
            atom_ = !obj.toString().equalsIgnoreCase("cohesion");
        }
    }
    
    public void setAtom(boolean t)
    {
        atom_ = t;
    }
    
    public boolean getAtom()
    {
        return atom_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:begin");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:transaction-type", (atom_ ? "atom" : "cohesion")));
        addQualifiers(el);
        addTargetAddress(el);
        addReplyAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Begin obj = new Begin();
        obj.setAtom(false);
        obj.setTransactionId("123456");
        System.err.println(obj.toString());
        obj = new Begin(obj.toXml());
        System.out.println(obj.toString());
    }
}
