
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Confirm extends Message{
	
    private String inferiorIdentifier_ = null;
    
    public Confirm()
    {
        super("btp:confirm", Message.TYPE_CONFIRM);
    }
    
    public Confirm(XElement el)
    {
        super(el, Message.TYPE_CONFIRM);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:confirm/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:confirm");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Confirm obj = new Confirm();
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        System.out.println(obj.toString());
        obj = new Confirm(obj.toXml());
        System.out.println(obj.toString());
    }
}
