
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Confirmed extends Message{
	 
	
    private boolean confirmedReceived_ = true;
    
    private String superiorIdentifier_ = null;
    
    private String inferiorIdentifier_ = null;
    
    public Confirmed()
    {
        super("btp:confirmed", Message.TYPE_CONFIRMED);
    }
    
    public Confirmed(XElement el)
    {
        super(el, Message.TYPE_CONFIRMED);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:confirmed/btp:default-is-cancel");
        if (obj != null)
        {
            confirmedReceived_ = !obj.toString().equalsIgnoreCase("false");
        }
        obj = h.getSingle("/btp:confirmed/btp:superior-identifier");
        if (obj != null)
        {
            superiorIdentifier_ = obj.toString();
        }
        obj = h.getSingle("/btp:confirmed/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setConfirmedReceived(boolean response)
    {
        confirmedReceived_ = response;
    }
    
    public boolean getConfirmedReceived()
    {
        return confirmedReceived_;
    }
    
    public void setSuperiorIdentifier(String uri)
    {
        superiorIdentifier_ = uri;
    }
    
    public String getSuperiorIdentifier()
    {
        return superiorIdentifier_;
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:confirmed");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:superior-identifier", superiorIdentifier_));
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        el.addElement(
            new XElement("btp:default-is-cancel",
                         (confirmedReceived_ ? "true" : "false")));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Confirmed obj = new Confirmed();
        obj.setSuperiorIdentifier("http://www.myaddress.com:8080/superiorid");
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        obj.setConfirmedReceived(false);
        System.out.println(obj.toString());
        obj = new Confirmed(obj.toXml());
        System.out.println(obj.toString());
    }
}
