
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class Hazard extends Message{
	    private String level_ = "mixed";
	    
	    private String superiorIdentifier_ = null;
	    
	    private String inferiorIdentifier_ = null;
	    
	    private String hazardInfo = null;
	    
	    public Hazard()
	    {
	        super("btp:hazard", Message.TYPE_HAZARD);
	    }
	    
	    public Hazard(XElement el)
	    {
	        super(el, Message.TYPE_HAZARD);
	        XHashtable h = el.toHashtable();
	        id_ = el.getAttribute("id");
	        Object obj = h.getSingle("/btp:hazard/btp:level");
	        if (obj != null)
	        {
	            level_ = obj.toString();
	        }
	        obj = h.getSingle("/btp:hazard/btp:superior-identifier");
	        if (obj != null)
	        {
	            superiorIdentifier_ = obj.toString();
	        }
	        obj = h.getSingle("/btp:hazard/btp:inferior-identifier");
	        if (obj != null)
	        {
	            inferiorIdentifier_ = obj.toString();
	        }
	        obj = h.getSingle("/btp:hazard/btp:hazard-information");
	        if (obj != null)
	        {
	            inferiorIdentifier_ = obj.toString();
	        }
	    }
	    
	    public void setLevel(String level)
	    {
	        level_ = level;
	    }
	    
	    public String getLevel()
	    {
	        return level_;
	    }
	    
	    public void setSuperiorIdentifier(String uri)
	    {
	        superiorIdentifier_ = uri;
	    }
	    
	    public String getSuperiorIdentifier()
	    {
	        return superiorIdentifier_;
	    }
	    
	    public void setInferiorIdentifier(String uri)
	    {
	        inferiorIdentifier_ = uri;
	    }
	    
	    public String getInferiorIdentifier()
	    {
	        return inferiorIdentifier_;
	    }
	    
	    public String geHazardInfo()
	    {
	        return this.hazardInfo;
	    }
	    
	    public void setHazardInfo(String info)
	    {
	        this.hazardInfo = info;
	    }
	    
	    public XElement toXml()
	    {
	        XElement el = new XElement("btp:hazard");
	        if (id_ != null)
	        {
	            el.addAttribute("id", id_);
	        }
	        el.addElement(
	            new XElement("btp:superior-identifier", superiorIdentifier_));
	        el.addElement(
	            new XElement("btp:inferior-identifier", inferiorIdentifier_));
	        el.addElement(
	            new XElement("btp:level", level_));
	        el.addElement(
	            new XElement("btp:hazard-information", hazardInfo));
	        addQualifiers(el);
	        addTargetAddress(el);
	        addSenderAddress(el);
	        return el;
	    }
	    public static void main(String args[])
	    {
	        System.out.println("===== Build hazard");
	        Hazard obj = new Hazard();
	        obj.setSuperiorIdentifier("http://www.myaddress.com:8080/superiorid");
	        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
	        obj.setLevel("possible");
	        System.out.println(obj.toString());
	        System.out.println("===== Extract hazard");
	        obj = new Hazard(obj.toXml());
	        System.out.println(obj.toString());
	    }
}
