
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Prepare extends Message{
	  
    private String inferiorIdentifier_ = null;
    
    public Prepare()
    {
        super("btp:prepare", Message.TYPE_PREPARE);
    }
    
    public Prepare(XElement el)
    {
        super(el, Message.TYPE_PREPARE);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:prepare/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:prepare");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Prepare obj = new Prepare();
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        System.out.println(obj.toString());
        obj = new Prepare(obj.toXml());
        System.out.println(obj.toString());
    }
}
