
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Prepared extends Message{
    
    private boolean defaultIsCancel_ = true;
    
    private String superiorIdentifier_ = null;
    
    private String inferiorIdentifier_ = null;
    
    public Prepared()
    {
        super("btp:prepared", Message.TYPE_PREPARED);
    }
    
    public Prepared(XElement el)
    {
        super(el, Message.TYPE_PREPARED);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:prepared/btp:default-is-cancel");
        if (obj != null)
        {
            defaultIsCancel_ = !obj.toString().equalsIgnoreCase("false");
        }
        obj = h.getSingle("/btp:prepared/btp:superior-identifier");
        if (obj != null)
        {
            superiorIdentifier_ = obj.toString();
        }
        obj = h.getSingle("/btp:prepared/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setDefaultIsCancel(boolean response)
    {
        defaultIsCancel_ = response;
    }
    
    public boolean getDefaultIsCancel()
    {
        return defaultIsCancel_;
    }
    
    public void setSuperiorIdentifier(String uri)
    {
        superiorIdentifier_ = uri;
    }
    
    public String getSuperiorIdentifier()
    {
        return superiorIdentifier_;
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:prepared");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:superior-identifier", superiorIdentifier_));
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        el.addElement(
            new XElement("btp:default-is-cancel",
                         (defaultIsCancel_ ? "true" : "false")));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Prepared obj = new Prepared();
        obj.setSuperiorIdentifier("http://www.myaddress.com:8080/superiorid");
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        obj.setDefaultIsCancel(false);
        System.out.println(obj.toString());
        obj = new Prepared(obj.toXml());
        System.out.println(obj.toString());
    }
}
