
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class Resigned extends Message{
	
	  
    private String inferiorIdentifier_ = null;
    
    public Resigned()
    {
        super("btp:resigned", Message.TYPE_RESIGNED);
    }
    
    public Resigned(XElement el)
    {
        super(el, Message.TYPE_RESIGNED);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:resigned/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:resigned");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        System.out.println("===== Build resigned");
        Resigned obj = new Resigned();
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        System.out.println(obj.toString());
        System.out.println("===== Extract resigned");
        obj = new Resigned(obj.toXml());
        System.out.println(obj.toString());
    }
}
