
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Status extends Message{
        public static final String STATUS_ACTIVE = "Active";
    public static final String STATUS_CANCELLED = "Cancelled";
    public static final String STATUS_CANCELLING = "Cancelling";
    public static final String STATUS_CANCEL_CONTRADICTION =
        "Cancel-contradiction";
    public static final String STATUS_CONFIRMED = "Confirmed";
    public static final String STATUS_CONFIRMING = "Confirming";
    public static final String STATUS_CONFIRM_CONTRADICTION =
        "Confirm-contradiction";
    public static final String STATUS_CONTRADICTED = "Contradicted";
    public static final String STATUS_CREATED = "Created";
    public static final String STATUS_ENROLLING = "Enrolling";
        public static final String STATUS_FAULT = "Fault";
    public static final String STATUS_HAZARD = "Hazard";
    public static final String STATUS_INACCESSIBLE = "Inaccessible";
    public static final String STATUS_PREPARED = "Prepared";
    public static final String STATUS_PREPARING = "Preparing";
    public static final String STATUS_RESIGNED = "Resigned";
    public static final String STATUS_RESIGNING = "Resigning";
    public static final String STATUS_UNKNOWN = "Unknown";
        public static final String STATUS_ABORTED = "Aborted";
    
    private String status_ = "Unknown";
    
    private String respondersIdentifier_ = null;
    
    public Status()
    {
        super("btp:status", Message.TYPE_STATUS);
    }
    
    public Status(String value)
    {
        super("btp:status", Message.TYPE_STATUS);
        status_ = value;
    }
    
    public Status(XElement el)
    {
        super(el, Message.TYPE_STATUS);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:status/btp:status-value");
        status_ = obj.toString();
        obj = h.getSingle("/btp:status/btp:responders-identifier");
        respondersIdentifier_ = obj.toString();
    }
    
    public void setStatus(String value)
    {
        status_ = value;
    }
    
    public String getStatus()
    {
        return status_;
    }
    
    public void setRespondersIdentifier(String uri)
    {
        respondersIdentifier_ = uri;
    }
    
    public String getRespondersIdentifier()
    {
        return respondersIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:status");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:responders-identifier", respondersIdentifier_));
        el.addElement(
            new XElement("btp:status-value", status_));
        addQualifiers(el);
        addTargetAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        System.out.println("===== Build status");
        Status obj = new Status();
        obj.setRespondersIdentifier("http://www.myaddress.com:8080/responseid");
        obj.setStatus("Confirm-contradiction");
        obj.setInferiorName("inferiornamw");
        System.out.println(obj.toString());
        System.out.println("===== Extract status");
        obj = new Status(obj.toXml());
        System.out.println(obj.toString());
    }
}
