
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class StatusItem extends Message{
	   
    private String infid_;
    
    private String status_;
    
    public StatusItem(String infid, String stat)
    {
        super("btp:status-item", Message.TYPE_UNKNOWN);
        infid_ = infid;
        status_ = stat;
    }
    
    public StatusItem(XElement el)
    {
        super(el, Message.TYPE_UNKNOWN);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        infid_ = pickString(h,
                            "/" + name_ + "/" + ns + "inferior-identifier");
        status_ = pickString(h,
                             "/" + name_ + "/" + ns + "status");
    }
    
    public String getInferiorIdentifier()
    {
        return infid_;
    }
    
    public String getStatus()
    {
        return status_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:status-item");
        el.addElement(new XElement("btp:inferior-identifier", infid_));
        el.addElement(new XElement("btp:status", status_));
        addQualifiers(el);
        return el;
    }
    public static void main(String args[])
    {
        StatusItem obj = new StatusItem("inferior1", "active");
        System.out.println(obj.toXml().toString());
    }
}
