
package org.act.services.transaction.participant;


import java.lang.reflect.Method;
import java.util.Vector;
import org.act.services.transaction.exception.TxException;
import org.act.services.transaction.manager.Resource;
import org.act.services.transaction.messages.Address;
import org.act.services.transaction.messages.ApplicationMessage;
import org.act.services.transaction.messages.Cancel;
import org.act.services.transaction.messages.Confirm;
import org.act.services.transaction.messages.ConfirmOnePhase;
import org.act.services.transaction.messages.Context;
import org.act.services.transaction.messages.ContextReply;
import org.act.services.transaction.messages.Enrol;
import org.act.services.transaction.messages.Enrolled;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.messages.Prepare;
import org.act.services.transaction.messages.Redirect;
import org.act.services.transaction.messages.RelatedGroup;
import org.act.services.transaction.messages.RequestStatus;
import org.act.services.transaction.messages.Status;
import org.act.services.transaction.messages.SuperiorState;
import org.act.services.transaction.util.LogCategory;
import org.act.services.transaction.util.MessageUtil;
import org.act.services.transaction.util.TxUri;
import org.apache.log4j.Category;
import org.act.metaset.*;;
public  class Participant extends Inferior{
	
	
	
    public Participant()
    {   
        super(LogCategory.getCategory(""));
    }
    
    public Participant(Category log)
    {
        super(log);
    }
        Message response=null;
    public synchronized void SetEnrollResponse(Message EnRs){
    	response=EnRs;
    }
        
    public String onMessage(String xml)
    {
        try
        {
            Message m = MessageUtil.parseMessage(xml);
            switch (m.getType())
            {
                case Message.TYPE_RELATED_GROUP:
                    return onRelatedGroup((RelatedGroup)m).toString();
                case Message.TYPE_CONTEXT:
                    return onContext((Context)m).toString();
                case Message.TYPE_CONFIRM:
                    return onConfirm((Confirm)m).toString();
                case Message.TYPE_CONFIRM_ONE_PHASE:
                    return onConfirmOnePhase((ConfirmOnePhase)m).toString();
                case Message.TYPE_PREPARE:
                    return onPrepare((Prepare)m).toString();
                case Message.TYPE_CANCEL:
                    return onCancel((Cancel)m).toString();
                case Message.TYPE_REDIRECT:
                    return onRedirect((Redirect)m).toString();
                case Message.TYPE_REQUEST_STATUS:
                    return onRequestStatus((RequestStatus)m).toString();
                case Message.TYPE_SUPERIOR_STATE:
                    return onSuperiorState((SuperiorState)m).toString();
                case Message.TYPE_ENROLLED:
                    return onEnrolled((Enrolled)m).toString();
                case Message.TYPE_UNKNOWN:
                default:
                    return onApplicationMessage((ApplicationMessage)m).toString();
            }
        }
        catch (Exception e)
        {
            return reportFault("Participant onMessage Exception:" + e.getMessage()).toString();
        }
    }
        
    	 
   public void enrolled(String transactionid){
	   
   }
   
   public int prepare(String transactionid)
       throws TxException{
	   return 0;
   }
   
   public void cancel(String transactionid)
       throws TxException{
	   
   }
   
   public void confirm(String transactionid)
       throws TxException{
	   
   }
   
   public void confirm_one_phase(String transactionid)
       throws TxException{
	   
   }
   
   public Message onContext(Context context)
   {
       String superiorId = context.getSuperiorIdentifier();
       txId = TxUri.getTransactionIdFromUri(superiorId);
       String inferAdd = getWebServiceUrl();
       String inferiorId = TxUri.buildUri(inferAdd, txId);
              if (ic == null)
       {
           boolean result = doEnrol(context);
           if (result == true)
           {
               ContextReply cxReply = new ContextReply(superiorId,
                   ContextReply.
                   ContextReply_completed);
               cxReply.setInferiorId(inferiorId);
               logger().debug("[" + inferiorId + "]ǼǳɹContextreplyϢ");
               return cxReply;
           }
           else
           {
               return reportFault("inferior[" + inferiorId +
                                  "] cannot be enrolled");
           }
       }
              else
       {
           ContextReply cxReply = new ContextReply(superiorId,
               ContextReply.
               ContextReply_completed);
           cxReply.setInferiorId(inferiorId);
           logger().debug("[" + inferiorId + "]ǼǳɹContextreplyϢ");
           return cxReply;
       }
   }
   
   synchronized boolean doEnrol(Context context)
   {
       boolean enrolled = false;
       String superId = context.getSuperiorIdentifier();
       txId = TxUri.getTransactionIdFromUri(superId);
       String inferAdd = getWebServiceUrl();
       String inferiorId = TxUri.buildUri(inferAdd, txId);
      
              Enrol enrol = new Enrol();
              enrol.setSuperiorIdentifier(superId);
              enrol.setInferiorIdentifier(inferiorId);
              Address add = new Address(getWebServiceUrl());
       enrol.addInferiorAddress(add);
     
              enrol.setResponseRequested(true);
              enrol.setTransactionId(txId);
       System.err.println(txId) ;
              Vector supAdds = context.getSuperiorAddresses();
       try
       {    
           for (int i = 0; i < supAdds.size(); i++)
           {
               String supAdd = ((Address)supAdds.get(i)).getAddress();
                                                            
               response= EnrollProxy.sendEnrollMessage(supAdd, enrol,txId);
                                  
           
                              if (response.getType() == Message.TYPE_ENROLLED)
               {
                   enrolled = true;
                   System.err.println(""+inferAdd+"õ˵ǼӦ");
                                  }
               
           }
       
       }
       catch (Exception e)
       {
           logger().error("[" + TxUri.getUrlFromUri(inferiorId) + "]Ǽʧ:" +
                          e.getMessage());
       }
              if (enrolled)
       {
                      ic = new InferiorContext(txId);
           ic.setInferiorId(inferiorId);
           ic.setSuperiorId(superId);
                      ic.setInfeirorAddress(inferAdd);
           ic.setStatus(Status.STATUS_ACTIVE);
           System.err.println(""+inferAdd+"Ĺ");
                      try{
        	           	   Method method_t=this.getMethod("enrolled");
        	           	   Object obj=this.GetWsInstance();
        	           	   Object[] par=new Object[]{txId};
        	   method_t.invoke(obj,par);
        	 
           }catch(Exception e){
        	   e.printStackTrace();
           }
       }
       return enrolled;
   }
   public InferiorContext getIC(){
	   return this.ic;
   }
   
}
