
package org.act.services.transaction.util;
import java.util.Date;
import java.util.Locale;
import java.text.DateFormat;
import java.util.Calendar;
import org.act.services.runtime.Application;

public class Timer {
	  
    public static String computeTime(long startTime, long stopTime)
    {
        long lapsedTime = stopTime - startTime;
        long minutes = lapsedTime / 60000;
        long seconds = (lapsedTime - 60000 * minutes) / 1000;
        long millisecond = lapsedTime - 60000 * minutes - 1000 * seconds;
        return minutes + "" + seconds + "" + millisecond + "";
    }
    
    public static String getCNTime()
    {
        Date date = new Date();
        Locale locale = Locale.CHINA;
        DateFormat fullDateFormat =
            DateFormat.getDateTimeInstance(
            DateFormat.FULL,
            DateFormat.FULL,
            locale);
        return fullDateFormat.format(date);
    }
    
    public static String getUSTime()
    {
        Date date = new Date();
        Locale locale = Locale.US;
        DateFormat fullDateFormat =
            DateFormat.getDateTimeInstance(
            DateFormat.FULL,
            DateFormat.FULL,
            locale);
        return fullDateFormat.format(date);
    }
    
    public static String getTime()
    {
        Calendar C = Calendar.getInstance(
            Locale.CHINA);
        return C.get(Calendar.YEAR) + "/" +
            (C.get(Calendar.MONTH) + 1) + "/" +             C.get(Calendar.DATE) + "-" +
            (Calendar.AM == C.get(Calendar.AM_PM) ? "AM" : "PM")
            + "-" +
            C.get(Calendar.HOUR_OF_DAY) + "_" +
            C.get(Calendar.MINUTE) + "_" +
            C.get(Calendar.SECOND) + "_" +
            C.get(Calendar.MILLISECOND);
    }
    public static void main(String[] args)
    {
        Date date = new Date();
                        Timer timer1 = new Timer();
        if (Application.isDebug()) {
        System.out.println(Timer.getCNTime());
        System.out.println(Timer.getUSTime());
        System.out.println(Timer.getTime());
        }
    }
}
