
package org.act.services.workflow.transaction;
import org.act.services.IMessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.IRuntime;
import org.act.services.thread.Terminatable;
import org.act.services.thread.ThreadPool;
import org.act.services.transaction.manager.Decider;
import org.act.services.transaction.manager.DeciderRunningPool;
import org.act.services.transaction.manager.InferiorResource;
import org.act.services.transaction.messages.Enrol;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.util.MessageUtil;
import org.act.metaset.*;;

public class WorkflowTransactionManager extends Terminatable {
	private ThreadPool threadPool;
	
	
	public WorkflowTransactionManager(IObjectPool msgInputPool,
			IObjectPool msgOutputPool, ThreadPool threadPool, IRuntime runtime){
        		this.msgIn = msgInputPool;
				this.msgOut = msgOutputPool;
		this.threadPool = threadPool;
		this.runtime = runtime;
				MessageUtil msgutil=new MessageUtil(this.msgOut,this.threadPool,this.runtime);
	}
	private IObjectPool msgIn = null;
	private IObjectPool msgOut = null;
	private IRuntime runtime = null;
		    	private String btpmsg=null;
	private String urlpoint=null;
	private String txid=null;
		
	public void process() {
		        		
		IMessageContext mc = null;
		synchronized (msgIn) {
			while (msgIn.empty()) {
				switch (getState()) {
				case RUNNING:
					try {
						msgIn.wait();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					break;
				case STOPPING:
					return;
				default:
					throw new IllegalMonitorStateException();
				}
			}
			mc =  (IMessageContext) msgIn.get();
	}
                		Metaset requestMsg=mc.getRequestServices();
		
				
		Metaset header_m=requestMsg.filter(".\\Header").car();
						if(header_m.getChilds().size()==1){
			requestMsg.remove(header_m);
			header_m=requestMsg.filter(".\\Header").car();
		}
						Metaset txid_s=header_m.filter(".\\TransactionID").car();
        String txid=txid_s.getValue();
                Metaset btp_s=header_m.filter(".\\message").car();
        String btp_m=btp_s.car().toXML().toString();
                Metaset response=null;
        try{
        	Message msg=MessageUtil.parseMessage(btp_m);
        	int msgtype=msg.getType();
        	        	if(msgtype==Message.TYPE_ENROL){
                Decider decider=(Decider)DeciderRunningPool.getDecider(txid);
                Message retMsg = decider.onEnrol((Enrol)msg);
                                String retm=retMsg.toString();
                                response=TransactionMessageContext.GetResponse(txid,retm);
                mc.setResponseServices(response);
                mc.setRequestServices(null);
                                synchronized (msgOut) {
       			msgOut.put(mc);
      			msgOut.notifyAll();
       		}
        	}
                            
        }catch(Exception e){
        	e.printStackTrace();
        }
        
        
        
        
}
}
