package org.act.services.protocol.http;
import java.io.IOException;
import java.net.Socket;
import java.util.logging.Logger;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.IConfigurable;
import org.act.services.locale.StringManager;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.ProtocolDescriptor;
import org.act.services.protocol.TransportProtocol;
import org.act.services.runtime.IRuntime;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.Terminatable;
import org.act.services.thread.ThreadPool;

public class HTTP11TransportProtocol extends TransportProtocol {
	static Logger log = Logger.getLogger(IRuntime.class.getName());
	static StringManager sm = StringManager.getManager("org.act.services.locale");
	Terminatable request = null;
	
	public void config(Metaset config) throws ConfigException {
		ProtocolDescriptor descriptor = new ProtocolDescriptor();
		descriptor.setName(config.selector(".\\","name"));
		descriptor.setVersion(config.selector(".\\","version"));
		descriptor.setDescription(config.selector(".\\","description"));
		String enabled= config.selector(".\\","enabled");
		if (enabled!=null && enabled.equals("false")) {
			this.setEnabled(false);
		}
		else {
			this.setEnabled(true);
		}
						request = new HTTPRequestListener(getTransportInputPool(),getThreadPool());
		if (request instanceof IConfigurable) {
			((IConfigurable)request).config(config);
		}
	}
	public HTTP11TransportProtocol() {
	}
	public Object adapt(Object obj) {
		if (obj instanceof HTTPTransportContext.HTTPResponseContext) {
			return new HTTPResponseProcessor((HTTPTransportContext.HTTPResponseContext)obj);
		}

		return null;
	}
	public void start() {
				if (isEnabled() && !isRunning()) {
			Thread t = new Thread(request);			t.setName("HTTP Transport Listener");
			t.start();
						setRunning(true);
		}
	}
	public void stop() {
		if (isEnabled()&& isRunning()) {
			request.terminate();
			setRunning(false);
		}
	}
	
}
