
package org.act.services.protocol.http;
import java.io.UnsupportedEncodingException;

public final class HTTPConstants {
        
    public static final String Package = "org.act.services.protocol.http";
    public static final int DEFAULT_CONNECTION_LINGER = -1;
    public static final int DEFAULT_CONNECTION_TIMEOUT = 60000;
    public static final int DEFAULT_CONNECTION_UPLOAD_TIMEOUT = 300000;
    public static final int DEFAULT_SERVER_SOCKET_TIMEOUT = 0;
    public static final boolean DEFAULT_TCP_NO_DELAY = true;
    
    
    public static final String SERVER = "BUAA_CSE/1.1";
    
    public static final byte CR = (byte) '\r';
    
    public static final byte LF = (byte) '\n';
    
    public static final byte SP = (byte) ' ';
    
    public static final byte HT = (byte) '\t';
    
    public static final byte COLON = (byte) ':';
    
    public static final byte A = (byte) 'A';
    
    public static final byte a = (byte) 'a';
    
    public static final byte Z = (byte) 'Z';
    
    public static final byte QUESTION = (byte) '?';
    
    public static final byte LC_OFFSET = A - a;
    
    public static final int DEFAULT_HTTP_HEADER_BUFFER_SIZE = 48 * 1024;
    
    public static final String CRLF = "\r\n";
    
    public static final byte[] CRLF_BYTES = {(byte) '\r', (byte) '\n'};
    
    public static final byte[] COLON_BYTES = {(byte) ':', (byte) ' '};
    
    public static final byte[] CLOSE_BYTES = {
        (byte) 'c',
        (byte) 'l',
        (byte) 'o',
        (byte) 's',
        (byte) 'e'
    };
    
    public static final byte[] KEEPALIVE_BYTES = {
        (byte) 'k',
        (byte) 'e',
        (byte) 'e',
        (byte) 'p',
        (byte) '-',
        (byte) 'a',
        (byte) 'l',
        (byte) 'i',
        (byte) 'v',
        (byte) 'e'
    };
    
    public static final int IDENTITY_FILTER = 0;
    
    public static final int CHUNKED_FILTER = 1;
    
    public static final int VOID_FILTER = 2;
    
    public static final int GZIP_FILTER = 3;
    
    public static final int BUFFERED_FILTER = 3;
    
    public static final String HTTP_10 = "HTTP/1.0";
    
    public static final String HTTP_11 = "HTTP/1.1";
    
    public static final String GET = "GET";
    
    public static final String HEAD = "HEAD";
    
    public static final String POST = "POST";
    
    public static final String CONTENTTYPE="Content-Type";
    
    public static final String CONTENTLENGTH="Content-Length";
    
    public static final byte[] ACK_BYTES = {
        (byte) 'H',
        (byte) 'T',
        (byte) 'T',
        (byte) 'P',
        (byte) '/',
        (byte) '1',
        (byte) '.',
        (byte) '1',
        (byte) ' ',
        (byte) '1',
        (byte) '0',
        (byte) '0',
        (byte) ' ',
        (byte) 'C',
        (byte) 'o',
        (byte) 'n',
        (byte) 't',
        (byte) 'i',
        (byte) 'n',
        (byte) 'u',
        (byte) 'e',
        (byte) '\r',
        (byte) '\n',
        (byte) '\r',
        (byte) '\n'
    };
    
    public static String getString(final byte[] data, int offset, int length) {
        if (data == null) {
            throw new IllegalArgumentException("Parameter may not be null");
        }
       
            return new String(data, offset, length);      
        }
    

public static String getString(final byte[] data) {
    return getString(data, 0, data.length);
}
}
