package org.act.services.workflow.connector;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.connector.AObjectPoolConnector;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.IRuntime;
import org.act.services.runtime.lifecycle.LiftcycleException;
import org.act.services.thread.ThreadPool;
import org.act.services.workflow.manager.WorkflowGlobalManager;

public class WSWFConnector extends AObjectPoolConnector {
	public WSWFConnector(IRuntime runtime) {
		super(runtime);
	}
	private ThreadPool threadPool;
	private IObjectPool msgInputPool;
	
	private WorkflowGlobalManager wgm;
	
	public Object adapt(Object obj) {
		return null;
	}
	
	public void start() throws LiftcycleException {
		Thread t = new Thread(wgm);
		t.setName("Global Manager");
		t.start();
	}
	
	public void stop() throws LiftcycleException {
		wgm.terminate();
		synchronized (msgInputPool) {
			msgInputPool.notifyAll();
		}
	}
	
	public void config(Metaset conf) throws ConfigException {
				super.config(conf);
		String msgIn = conf.selector(".\\","inputpool");
		msgInputPool = runtime.getObjectPool(msgIn, IObjectPool.IN_MODE);
				String tpName = conf.selector(".\\threadpool","name");		threadPool = runtime.getThreadPool(tpName);		
				wgm = new WorkflowGlobalManager(msgInputPool, threadPool,runtime);
	}
}
