
package org.act.services.workflow.data;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import org.act.metaset.Attribute;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class CorrelationSet {
	private Metaset correlationSets;
	private WorkflowRuntimeContext rc;
	
	public CorrelationSet(Metaset correlationSets, WorkflowRuntimeContext rc) {
		this.rc = rc;
		this.setCSs(correlationSets);
	}
	
							private Metaset getCorrelationSet(String csname) {
		Metaset cs = null;
		if (this.correlationSets != null) {
			cs = this.correlationSets.filter(".\\correlationSet", "name",
					csname);
		}
		Stack localKeepStack = this.rc.getLocalKeepStack();
		if (cs != null) {
			return cs.car();
		} else {
			for (int i = localKeepStack.size() - 3; i > 0; i = i - 6) {
				CorrelationSet correlationSet = (CorrelationSet) localKeepStack
						.get(i);
				Metaset tempCSs = correlationSet.getCorrelationSets();
				if (tempCSs != null) {
					Metaset tempCS = tempCSs.filter(".\\correlationSet",
							"name", csname);
					if (tempCS != null) {
						return tempCS.car();
					}
				}
			}
		}
		return null;
	}
	
	public void setCorrelationSetFromVar(String csname, String varname) {
		Metaset cs = this.getCorrelationSet(csname);
		List attributes = cs.getAttributes();
		for (int i = 0; i < attributes.size(); i++) {
			Attribute attribute = (Attribute) attributes.get(i);
			if (attribute.getName().equals("variable")) {
				attribute.setValue(varname);
			}
		}
	}
	
							public Metaset getCorrelationSetOnName(String csname) {
		Metaset cs = new Metaset("correlationSet");
		Attribute csName = new Attribute(new QName("name"), csname);
		cs.add(csName);
		Metaset csTemp = this.getCorrelationSet(csname);
		String var = csTemp.selector(".\\", "variable");
		for (int i = 0; i < csTemp.getChilds().size(); i++) {
			Metaset propertyAlias = (Metaset) csTemp.getChilds().get(i);
			String part = propertyAlias.selector(".\\", "part");
			Metaset prop = new Metaset("property");
			Attribute propName = new Attribute(new QName("name"), propertyAlias
					.selector(".\\", "propertyName"));
			prop.add(propName);
			Attribute value = new Attribute(new QName("value"), this.rc
					.getVariables().getVarPartValue(var, part));
			prop.add(value);
			cs.add(prop);
		}
		return cs;
	}
	
								public void setCSs(Metaset correlationSets) {
		if (correlationSets != null) {
			try {
				this.correlationSets = (Metaset) correlationSets.clone();
			} catch (CloneNotSupportedException e) {
								e.printStackTrace();
			}
			for (int i = 0; i < this.correlationSets.getChilds().size(); i++) {
				Metaset cs = (Metaset) this.correlationSets.getChilds().get(i);
				Attribute variable = new Attribute(new QName("variable"),
						"null");
				cs.add(variable);
				String properties = cs.selector(".\\", "properties");
				String sub = new String(properties);
				List propList = new ArrayList();
				int pos = sub.indexOf(" ");
				while (pos != -1) {
					String save = sub.substring(0, pos - 1);
					propList.add(save);
					sub = sub.substring(pos + 1);
					pos = sub.indexOf(" ");
				}
				propList.add(sub);
				for (int j = 0; j < propList.size(); j++) {
					String prop = (String) propList.get(j);
					String nameSpace = (new QName(prop)).getNameSpace();
					String name = (new QName(prop)).getName();
					Metaset wsdl = this.rc.getWc()
							.getWsdlOnNamespace(nameSpace);
										Metaset propertyAlias = null;
					try {
						propertyAlias = (Metaset) wsdl.filter(
								".\\propertyAlias", "propertyName",
								"tns:" + name).car().clone();
					} catch (CloneNotSupportedException e1) {
												e1.printStackTrace();
					}
					cs.add(propertyAlias);
				}
			}
		}
	}
	
	public WorkflowRuntimeContext getRc() {
		return rc;
	}
	
	public void setRc(WorkflowRuntimeContext rc) {
		this.rc = rc;
	}
	
	public Metaset getCorrelationSets() {
		return correlationSets;
	}
	
	public void setCorrelationSets(Metaset correlationSets) {
		this.correlationSets = correlationSets;
	}
}
