
package org.act.services.wsa;
import org.act.metaset.QName;
import org.act.services.soap.model.Body;
import org.act.services.soap.model.Envelope;
import org.act.services.soap.model.Header;
import org.act.services.soap.model.SoapAttribute;
import org.act.services.soap.model.SoapQName;

public class WSASoap12Binding extends WSASoapBinding implements IWSASoap12Binding {
	public WSASoap12Binding() {
		super();
	}
	public WSASoap12Binding(String name) {
		super(name);
	}
	public WSASoap12Binding(QName qName) {
		super(qName);
	}
	public WSASoap12Binding(String namespace, String name) {
		super(namespace, name);
	}
	
		public static Envelope sample() {
		
		
		
		Envelope soapenv = new Envelope("S", "Envelope");
		soapenv.add(new SoapAttribute(new SoapQName("xmlns", "S"), WSAddressingUtil.S));
		soapenv.add(new SoapAttribute(new SoapQName("xmlns", "wsa"), WSAddressingUtil.wsa));
		Header soaphead = new Header("S", "Header");
		
		MessageID wsamID = new MessageID("wsa", "MessageID");
		wsamID.setValue("http://example.com/6B29FC40-CA47-1067-B31D-00DD010662DA");
		soaphead.add(wsamID);
		
		ReplyTo wsart = new ReplyTo("wsa", "ReplyTo");
		Address wsaad = new Address("wsa", "Address");
		wsaad.setValue("http://example.com/business/client1");
		wsart.add(wsaad);
		soaphead.add(wsart);
		
		To soapto = new To("wsa", "To");
		soapto.setValue("http://example.com/fabrikam/Purchasing");
		soaphead.add(soapto);
		
		Action wsaaction = new Action("wsa", "Action");
		wsaaction.setValue("http://example.com/fabrikam/SubmitPO");
		soaphead.add(wsaaction);
		
		soapenv.add(soaphead);
		
		Body soapbody = new Body("S", "Body");
				
		soapenv.add(soapbody);
		
		return soapenv;
	}
	
	public static void main(String[] args)  {
		
		Envelope soaptest = sample();
		
		System.out.println(soaptest.toXML());
	}
}
