
package org.act.wsrf.basefaults;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.wsa.EndpointReference;

public class BaseFault extends Metaset{
	
	
	public BaseFault() {
		super();
			}
	
	public BaseFault(String name) {
		super(name);
			}
	
	public BaseFault(QName qName) {
		super(qName);
			}
	
	public BaseFault(String namespace, String name) {
		super(namespace, name);
			}
		public static BaseFault sample() {
		
		
		
		BaseFault basefault = new BaseFault("wsbf", "BaseFault");
		basefault.add(new BaseFaultAttribute(new BaseFaultQName("xmlns", "xsd"), BaseFaultUtil.xsd));
		basefault.add(new BaseFaultAttribute(new BaseFaultQName("xmlns", "xsi"), BaseFaultUtil.xsi));
		basefault.add(new BaseFaultAttribute(new BaseFaultQName("xmlns", "wsbf"), BaseFaultUtil.wsbf));
		basefault.add(new BaseFaultAttribute(new BaseFaultQName("xmlns", "wsa"), BaseFaultUtil.wsa));
		Timestamp timestamp = new Timestamp("wsbf", "Timestamp");
		timestamp.setValue("xsd:dateTime");
		basefault.add(timestamp);
		
		OriginatorReference orf = new OriginatorReference("wsbf", "OriginatorReference");
		EndpointReference er = new EndpointReference("wsa", "EndpointReference");
		orf.add(er);
		basefault.add(orf);
		ErrorCode ec = new ErrorCode("wsbf", "ErrorCode");
		ec.add(new BaseFaultAttribute(new BaseFaultQName("xsd", "dialect"), "anyURI"));
		ec.setValue("xsd:string");
		basefault.add(ec);
		
		Description ds = new Description("wsbf", "Description");
		ds.setValue("xsd:string");
		basefault.add(ds);
		
		FaultCause fc = new FaultCause("wsbf", "FaultCause");
		BaseFault newbf = new BaseFault("wsbf", "BaseFault");
		fc.add(newbf);
		basefault.add(fc);
		
		return basefault;
	}
	
	public static void main(String[] args)  {
		
		BaseFault bf = sample();
		
		System.out.println(bf.toXML());
	}
}
