
package org.act.wsrf.resourceproperties.faults;
import org.act.wsrf.basefaults.BaseFault;
import org.act.wsrf.basefaults.Description;
import org.act.wsrf.basefaults.ErrorCode;
import org.act.wsrf.basefaults.FaultCause;
import org.act.wsrf.basefaults.OriginatorReference;
import org.act.wsrf.basefaults.Timestamp;

public class ResourceNotDestroyedFault extends Exception {
	private BaseFault baseFault;
	
	public ResourceNotDestroyedFault(){
		super();
	}
	
	public ResourceNotDestroyedFault(String message){
		
	}
	
	public ResourceNotDestroyedFault(BaseFault baseFault){
		this.baseFault = baseFault;
	}
	
	public BaseFault setTimestamp(Timestamp ts){
		this.baseFault.add(ts);
		return this.baseFault;
	}
	
	public BaseFault setOriginatorReference(OriginatorReference or){
		this.baseFault.add(or);
		return this.baseFault;
	}
	
	public BaseFault setErrorCode(ErrorCode ec){
		this.baseFault.add(ec);
		return this.baseFault;
	}
	
	public BaseFault setDescription(Description des){
		this.baseFault.add(des);
		return this.baseFault;
	}
	
	public BaseFault setFaultCause(FaultCause fc){
		this.baseFault.add(fc);
		return this.baseFault;
	}
	
	public String toString(){
		return this.baseFault.toXML();
	}
}
